// DlgAddMaskCutout.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgAddMaskCutout.h"


// CDlgAddMaskCutout dialog

IMPLEMENT_DYNAMIC(CDlgAddMaskCutout, CDialog)

/*=============================================================================
						CDlgAddMaskCutout NX̍\z
=============================================================================*/

CDlgAddMaskCutout::CDlgAddMaskCutout(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgAddMaskCutout::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgAddMaskCutout)
	//}}AFX_DATA_INIT
}

/*=============================================================================
						CDlgAddMaskCutout NX̏
=============================================================================*/

CDlgAddMaskCutout::~CDlgAddMaskCutout()
{
}

/*=============================================================================
			CDlgAddMaskCutout _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgAddMaskCutout::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgAddMaskCutout)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_COMBO1, m_wndComboBox_layer);
	DDX_Control(pDX, IDC_RADIO1, m_wndRadioBtn_none);
	DDX_Control(pDX, IDC_RADIO2, m_wndRadioBtn_edge);
	DDX_Control(pDX, IDC_RADIO3, m_wndRadioBtn_full);
	if(!pDX->m_bSaveAndValidate)			/* ϐRg[	*/
	{
		// incoming
		m_wndComboBox_layer.InsertString( 0,_T("TOP SOLDER MASK"));
		m_wndComboBox_layer.InsertString( 1,_T("BOTTOM SOLDER MASK"));
		m_wndComboBox_layer.SetCurSel(0);
		m_wndRadioBtn_none.SetCheck(1);
	}
	else
	{
		// outgoing
		if( m_wndComboBox_layer.GetCurSel() == 0 )
			m_layer = LAY_SM_TOP;
		else if( m_wndComboBox_layer.GetCurSel() == 1 )
			m_layer = LAY_SM_BOTTOM;
		else
			ASSERT(FALSE);
		if( m_wndRadioBtn_none.GetCheck() )
			m_hatch = CPolyLine::NO_HATCH;
		else if( m_wndRadioBtn_edge.GetCheck() )
			m_hatch = CPolyLine::DIAGONAL_EDGE;
		else if( m_wndRadioBtn_full.GetCheck() )
			m_hatch = CPolyLine::DIAGONAL_FULL;
		else
			ASSERT(FALSE);
	}
}

/*=============================================================================
					NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgAddMaskCutout, CDialog)
	//{{AFX_MSG_MAP(CDlgAddMaskCutout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CDlgAddMaskCutout message handlers

/*-----------------------------------------------------------------------------
						end of DlgAddMaskCutout.cpp
-----------------------------------------------------------------------------*/
