#pragma once
#include "afxwin.h"


// CDlgAddPin dialog

/*=============================================================================
					CDlgAddPin _CAO NX̐錾
=============================================================================*/

class CDlgAddPin : public CDialog
{
	DECLARE_DYNAMIC(CDlgAddPin)
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
public:
	CDlgAddPin(CWnd* pParent = NULL);   // standard constructor 
	virtual ~CDlgAddPin();
	void InitDialog( CEditShape * fp, int mode, 
		int pin_num, int units );
//	void EnableFields();

protected:
	void SetFields();
	void GetFields();

	CEditShape * m_fp;	// original footprint
public:

//--------------------------------------
// _CAO f[^(萔)
//--------------------------------------
protected:
	//{{AFX_DATA(CDlgAddPin)
	enum { IDD = IDD_ADD_PIN };
	//}}AFX_DATA
public:
	enum { ADD, EDIT };		// modes
//--------------------------------------
// _CAO f[^(ϐ)
//--------------------------------------
public:
	BOOL		m_drag_flag;					/**< TRUE to drag pad after exiting				*/
	int			m_pin_num;						/**< pin num to EDIT							*/
	int			m_num_pins;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
protected:
	int			m_mode;							/**< ADD or EDIT								*/
	int			m_units;						/**< MIL or MM									*/

	CString		m_pin_name;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_increment;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_same_as_pin_flag;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CString		m_same_as_pin_name;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_padstack_type;				/**< 0=SMT, 1=TH, 2=SMT(bottom)					*/
	int			m_hole_diam;					/**< for TH										*/
	int			m_pad_orient;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	//-------------------------------------------
	// Member variables for [TOP] layer pad
	//-------------------------------------------
	int			m_top_shape;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_top_width;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_top_length;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_top_radius;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_top_mask_shape;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_top_mask_width;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_top_mask_length;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_top_mask_radius;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_top_paste_shape;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_top_paste_width;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_top_paste_length;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_top_paste_radius;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_top_flags;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	//-------------------------------------------
	// Member variables for [INNER] layer pad
	//-------------------------------------------
	int			m_inner_shape;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_inner_width;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_inner_length;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_inner_radius;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_inner_flags;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	//-------------------------------------------
	// Member variables for [BOTTOM] layer pad
	//-------------------------------------------
	BOOL		m_bottom_same_as_top;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_bottom_shape;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_bottom_width;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_bottom_length;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_bottom_radius;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_bottom_mask_shape;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_bottom_mask_width;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_bottom_mask_length;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_bottom_mask_radius;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_bottom_paste_shape;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_bottom_paste_width;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_bottom_paste_length;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_bottom_paste_radius;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_bottom_flags;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/

	int			m_x;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_y;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_x_edge;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_y_edge;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/

	int			m_row_orient;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_row_spacing;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
private:
	CButton		m_wndRadioBtn_add_pin;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_add_row;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox	m_wndComboBox_units;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_same_as_pin;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_smt;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_smt_bottom;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_th;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox	m_wndComboBox_same_as_pin;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_pin_name;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_num_pins;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_increment;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_hole_diam;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_drag;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_pin_x;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_pin_y;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	//-------------------------------------------
	// Dialog controls for [TOP] layer pad
	//-------------------------------------------
	CComboBox	m_wndComboBox_top_shape;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_top_width;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_top_length;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_top_radius;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox	m_wndComboBox_top_shape2;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_top_width2;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_top_length2;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_top_radius2;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox	m_wndComboBox_top_shape3;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_top_width3;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_top_length3;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_top_radius3;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	//-------------------------------------------
	// Dialog controls for [INNNER] layer pad
	//-------------------------------------------
	CComboBox	m_wndComboBox_inner_shape;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_inner_width;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_inner_length;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_inner_radius;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	//-------------------------------------------
	// Dialog controls for [BOTTOM] layer pad
	//-------------------------------------------
	CButton		m_wndCheckBtn_bottom_same_as;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox	m_wndComboBox_bottom_shape;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_bottom_width;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_bottom_length;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_bottom_radius;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox	m_wndComboBox_bottom_shape2;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_bottom_width2;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_bottom_length2;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_bottom_radius2;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox	m_wndComboBox_bottom_shape3;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_bottom_width3;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_bottom_length3;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_bottom_radius3;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox	m_wndComboBox_row_orient;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_row_spacing;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/

	CListBox	m_wndListBoxPins;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox	m_wndComboBox_pad_orient;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox	m_wndComboBox_x_edge;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox	m_wndComboBox_y_edge;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_set_pos;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_connect[3][4];			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
//--------------------------------------
// Override(s) - yz֐z
//--------------------------------------
	//{{AFX_VIRTUAL(CDlgAddPin)
protected:
	virtual BOOL OnInitDialog();						/**< _CAȌ(WM_INITDIALOGbZ[Wւ̉)	*/
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
//--------------------------------------
// Generated message map function(s)
//--------------------------------------
protected:
	//{{AFX_MSG(CDlgAddPin)
	afx_msg void OnBnClickedRadioAddPin();
	afx_msg void OnBnClickedRadioAddRow();
	afx_msg void OnBnClickedRadioDragPin();
	afx_msg void OnBnClickedRadioSetPinPos();
	afx_msg void OnBnClickedCheckInnerSameAs();
	afx_msg void OnBnClickedCheckBottomSameAs();
	afx_msg void OnCbnSelchangeComboPinUnits();
	afx_msg void OnCbnSelchangeComboRowOrient();
	afx_msg void OnChange();
	afx_msg void OnChangeTopPadParam();
	//}}AFX_MSG
	afx_msg void OnCheckBtnClicked(UINT nCtrlID);
	afx_msg void OnRadioBtnClicked(UINT nCtrlID);
	afx_msg void OnEditTextChanged(UINT nCtrlID);
	afx_msg void OnDeltaPosSpin(UINT nCtrlID,NMHDR* pNMHDR, LRESULT* pResult);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
/*-----------------------------------------------------------------------------
							end of DlgAddPin.h
-----------------------------------------------------------------------------*/
