#pragma once
#include "afxwin.h"


// CDlgAddText dialog

/*=============================================================================
					CDlgAddText _CAO NX̐錾
=============================================================================*/

class CDlgAddText : public CDialog
{
	DECLARE_DYNAMIC(CDlgAddText)
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
public:
	CDlgAddText(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDlgAddText();
	void Initialize( BOOL fp_flag, int num_layers, int drag_flag, 
		CString * str, int units, int layer, int mirror, BOOL bNegative,
		int angle, int height, int width, int x, int y );
public:
	void SetFields();
	void GetFields();

//--------------------------------------
// _CAO f[^(萔)
//--------------------------------------
protected:
	//{{AFX_DATA(CDlgAddText)
	enum { IDD = IDD_ADD_TEXT };
	//}}AFX_DATA
//--------------------------------------
// Override(s) - yz֐z
//--------------------------------------
	//{{AFX_VIRTUAL(CDlgAddText)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
//--------------------------------------
// _CAO f[^(ϐ)
//--------------------------------------
public:
	BOOL	m_fp_flag;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int		m_drag_flag;					/**< if dragging to position					*/
	int		m_num_layers;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int		m_x, m_y;						/**< set on entry if editing					*/
	int		m_width;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int		m_height;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int		m_angle;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int		m_mirror;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	BOOL	m_bNegative;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int		m_layer;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int		m_units;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int		m_unit_mult;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CString	m_str;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
private:
	CListBox	m_layer_list;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_height;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndPushBtn_set_width;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndPushBtn_def_width;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_width;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_text;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_y;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_x;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndPushBtn_set_position;		/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CListBox	m_list_angle;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndPushBtn_drag;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox	m_wndComboBox_units;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_negative;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
//--------------------------------------
// Generated message map function(s)
//--------------------------------------
protected:
	//{{AFX_MSG(CDlgAddText)
	virtual BOOL OnInitDialog();
	afx_msg void OnBnClickedSetPosition();
	afx_msg void OnBnClickedDrag();
	afx_msg void OnEnChangeEditHeight();
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedSetWidth();
	afx_msg void OnBnClickedDefWidth();
	afx_msg void OnCbnSelchangeComboAddTextUnits();
	afx_msg void OnLbnSelchangeListLayer();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
/*-----------------------------------------------------------------------------
							end of DlgAddText.h
-----------------------------------------------------------------------------*/
