// DlgChangeLayer.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgChangeLayer.h"


// CDlgChangeLayer dialog

IMPLEMENT_DYNAMIC(CDlgChangeLayer, CDialog)

/*=============================================================================
						CDlgChangeLayer NX̍\z
=============================================================================*/

CDlgChangeLayer::CDlgChangeLayer(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgChangeLayer::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgChangeLayer)
	//}}AFX_DATA_INIT
}

/*=============================================================================
						CDlgChangeLayer NX̏
=============================================================================*/

CDlgChangeLayer::~CDlgChangeLayer()
{
}

/*=============================================================================
			CDlgChangeLayer _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgChangeLayer::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgChangeLayer)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_COMBO1, m_wndComboBox_layer);
	DDX_Control(pDX, IDC_RADIO_SEGMENT, m_wndRadioBtn_segment);
	DDX_Control(pDX, IDC_RADIO_TRACE, m_wndRadioBtn_trace);
	DDX_Control(pDX, IDC_RADIO_NET, m_wndRadioBtn_net);
	if(!pDX->m_bSaveAndValidate)			/* ϐRg[	*/
	{
		// incoming
		for( int il=0; il<m_num_copper_layers; il++ )
		{
			m_wndComboBox_layer.InsertString( il, CFreePcbApp::GetBoardLayerName(il+LAY_TOP_COPPER));
		}
		if( m_old_layer >= LAY_TOP_COPPER )
			m_wndComboBox_layer.SetCurSel( m_old_layer - LAY_TOP_COPPER );
		else
			m_wndComboBox_layer.SetCurSel( 0 );
		if( m_mode == 0 )
			m_wndRadioBtn_segment.SetCheck(1);
		else if( m_mode == 1 )
		{
			m_wndRadioBtn_trace.SetCheck(1);
			m_wndRadioBtn_segment.EnableWindow(0);
		}
		else if( m_mode == 2 )
		{
			m_wndRadioBtn_net.SetCheck(1);
			m_wndRadioBtn_segment.EnableWindow(0);
			m_wndRadioBtn_trace.EnableWindow(0);
		}
	}
	else
	{
		// outgoing
		m_new_layer = m_wndComboBox_layer.GetCurSel() + LAY_TOP_COPPER;
		if( m_wndRadioBtn_segment.GetCheck() )
			m_apply_to = 0;
		else if( m_wndRadioBtn_trace.GetCheck() )
			m_apply_to = 1;
		else if( m_wndRadioBtn_net.GetCheck() )
			m_apply_to = 2;
	}
}

/*=============================================================================
					CDlgChangeLayer NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgChangeLayer, CDialog)
	//{{AFX_MSG_MAP(CDlgChangeLayer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CDlgChangeLayer message handlers

/*=============================================================================

=============================================================================*/

void	CDlgChangeLayer::Initialize(int mode						/**< ToDo:Add Comment for Doxygen			*/
								   ,int old_layer					/**< ToDo:Add Comment for Doxygen			*/
								   ,int num_copper_layers			/**< ToDo:Add Comment for Doxygen			*/ )
{
	m_mode = mode;
	m_old_layer = old_layer;
	m_num_copper_layers = num_copper_layers;
}
