#pragma once
#include "DesignRules.h"
#include "afxwin.h"

// DlgDRC dialog

/*=============================================================================
				  DlgDRC _CAO NX̐錾
=============================================================================*/

class DlgDRC : public CDialog
{
	DECLARE_DYNAMIC(DlgDRC)
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
public:
	DlgDRC(CWnd* pParent = NULL);   // standard constructor
	virtual ~DlgDRC(); 
	void Initialize(int units
					,DesignRules * dr
					,CPartList * pl
					,CNetList * nl
					,DRErrorList * drelist
					,int copper_layers
					,CArray<CPolyLine> * board_outline
					,int CAM_annular_ring_pins
					,int CAM_annular_ring_vias);
//					,CDlgLog * log );
	void GetFields();
	void SetFields();
	void CheckDesign();
//--------------------------------------
// _CAO f[^(萔)
//--------------------------------------
protected:
	//{{AFX_DATA(DlgDRC)
	enum { IDD = IDD_DRC };
	//}}AFX_DATA
//--------------------------------------
// Override(s) - yz֐z
//--------------------------------------
	//{{AFX_VIRTUAL(DlgDRC)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

//--------------------------------------
// _CAO f[^(ϐ)
//--------------------------------------
public:
	DesignRules		m_dr_local;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_CAM_annular_ring_pins;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_CAM_annular_ring_vias;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
protected:
	int				m_units; 							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	DesignRules		*m_dr;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CPartList		*m_pl;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CNetList		*m_nl;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	DRErrorList		*m_drelist;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_copper_layers;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CArray<CPolyLine>	*m_board_outline;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
private:
	CComboBox		m_wndComboBox_units;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit			m_wndEditCtrl_pad_pad;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit			m_wndEditCtrl_pad_trace;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit			m_wndEditCtrl_trace_trace;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit			m_wndEditCtrl_hole_copper;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit			m_wndEditCtrl_annular_ring_pins;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit			m_wndEditCtrl_board_edge_copper;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit			m_wndEditCtrl_hole_hole;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit			m_wndEditCtrl_annular_ring_vias;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit			m_wndEditCtrl_copper_copper;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit			m_wndEditCtrl_trace_width;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit			m_wndEditCtrl_board_edge_hole;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton			m_wndCheckBtn_show_unrouted;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
//--------------------------------------
// Generated message map function(s)
//--------------------------------------
protected:
	//{{AFX_MSG(DlgDRC)
	afx_msg void OnCbnChangeUnits();
	afx_msg void OnBnClickedCancel();
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCheck();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
/*-----------------------------------------------------------------------------
							end of DlgDRC.h
-----------------------------------------------------------------------------*/
