#pragma once
#include "afxwin.h"
#include "NetList.h"


// CDlgEditNet dialog

/*=============================================================================
				  CDlgEditNet _CAO NX̐錾
=============================================================================*/

class CDlgEditNet : public CDialog
{
	DECLARE_DYNAMIC(CDlgEditNet)
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
public:
	CDlgEditNet(CWnd* pParent = NULL); 
	virtual ~CDlgEditNet();
	void Initialize( netlist_info * nl,	// netlist_info struct
				int i,					// index into nl (ignored if new net)
				CPartList * plist,		// partlist
				BOOL new_net,			// flag for new net
				BOOL visible,			// visibility flag
				int units,				// MIL or MM
				CArray<int> * w,		// array of default trace widths
				CArray<int> * v_w,		// array of default via widths
				CArray<int> * v_h_w );	// array of default via hole widths
	void SetFields();
	void GetFields();
	void ChangeTraceWidth( CString str );
//--------------------------------------
// _CAO f[^(萔)
//--------------------------------------
protected:
	//{{AFX_DATA(CDlgEditNet)
	enum { IDD = IDD_EDIT_NET };
	//}}AFX_DATA
//--------------------------------------
// Override(s) - yz֐z
//--------------------------------------
	//{{AFX_VIRTUAL(CDlgEditNet)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

//--------------------------------------
// _CAO f[^(ϐ)
//--------------------------------------
	CString		m_name;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	BOOL		m_new_net;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CArray<net_info> *m_nl;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CPartList	*m_plist;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_in;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	BOOL		m_visible;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_def_w;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_def_v_w;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_def_v_h_w;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	// pointers to arrays of default trace and via widths
	CArray<int> *m_w;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CArray<int> *m_v_w;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CArray<int> *m_v_h_w;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
protected:
	int			m_units;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	BOOL		m_pins_edited;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndPushBtn_def_width;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndPushBtn_set_width;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_pad_w;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_hole_w;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CListBox	m_list_pins;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_name;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_visible;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox	m_wndComboBox_width;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_addpin;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
public:
	CButton		m_wndCheckBtn_apply;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndPushBtn_add_pin;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndPushBtn_OK;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
//--------------------------------------
// Generated message map function(s)
//--------------------------------------
protected:
	//{{AFX_MSG(CDlgEditNet)
	virtual BOOL OnInitDialog();
	afx_msg void OnBnClickedButtonDelete();
	afx_msg void OnBnClickedButtonAdd();
	afx_msg void OnBnClickedRadioDefWidth();
	afx_msg void OnBnClickedRadioSetWidth();
	afx_msg void OnEnChangeEditWidth();
	afx_msg void OnCbnSelchangeComboWidth();
	afx_msg void OnCbnEditchangeComboWidth();
	afx_msg void OnEnUpdateEditAddPin();
	afx_msg void OnBnClickedOk();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
