// ivexDlg.cpp : implementation file
//

#include "stdafx.h"
//#include "ivex.h"
#include "DlgIvex.h"
#include "ivex_mod_file.h"
#include "file_io.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CivexDlg dialog

IMPLEMENT_DYNAMIC(CivexDlg, CDialog)

/*=============================================================================
							CivexDlg NX̍\z
=============================================================================*/

CivexDlg::CivexDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CivexDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CivexDlg)
	//}}AFX_DATA_INIT

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

/*=============================================================================
			CivexDlg _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CivexDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CivexDlg)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_EDIT_INFILE, m_wndEditCtrl_infile);
	DDX_Control(pDX, IDC_EDIT_OUTFILE, m_wndEditCtrl_outfile);
	DDX_Control(pDX, IDC_EDIT_MESSAGE, m_wndEditCtrl_messages);
	DDX_Control(pDX,IDC_PROGRESS1,m_wndProgressBar);
}

/*=============================================================================
				CivexDlg NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CivexDlg, CDialog)
	//{{AFX_MSG_MAP(CivexDlg)
	//}}AFX_MSG_MAP
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_INFILE, OnBnClickedButtonInfile)
	ON_BN_CLICKED(IDC_BUTTON_OUTFILE, OnBnClickedButtonOutfile)
	ON_EN_CHANGE(IDC_EDIT_INFILE, OnEnChangeEditInfile)
	ON_EN_CHANGE(IDC_EDIT_OUTFILE, OnEnChangeEditOutfile)
	ON_BN_CLICKED(ID_CONVERT, OnBnClickedConvert)
END_MESSAGE_MAP()


// CivexDlg message handlers

/*=============================================================================
					_CAȌ
=============================================================================*/

BOOL	CivexDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

/*=============================================================================

=============================================================================*/

void CivexDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	CDialog::OnSysCommand(nID, lParam);
}

/*=============================================================================

=============================================================================*/

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CivexDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

/*=============================================================================

=============================================================================*/

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CivexDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

/*=============================================================================

=============================================================================*/

void CivexDlg::OnBnClickedButtonInfile()
{
	// get project file name

	CString		strInputFilePathName;
	CString		strOutputFilePathName;

	m_wndEditCtrl_infile.GetWindowText(strInputFilePathName);
	CFileDialog wndDlg(TRUE																	/*									*/
					  ,_T(".mod")															/*									*/
					  ,!strInputFilePathName.IsEmpty() ? strInputFilePathName:_T("*.mod")	/*									*/
					  ,OFN_FILEMUSTEXIST|OFN_ENABLESIZING|OFN_NOCHANGEDIR|OFN_SHOWHELP		/*									*/
					  ,_T("Ivex library files (*.mod)|*.mod|All Files (*.*)|*.*||")			/*									*/
					  ,this																	/*									*/ );

	if(wndDlg.DoModal()==IDOK)
	{
		strInputFilePathName=wndDlg.GetPathName();
		m_wndEditCtrl_infile.SetWindowText(strInputFilePathName);

		m_wndEditCtrl_outfile.GetWindowText(strOutputFilePathName);
//		if((strOutputFilePathName.IsEmpty())
//		&& (strInputFilePathName.Right(4).CompareNoCase(_T(".mod"))==0))
		{
			m_wndEditCtrl_outfile.SetWindowText(strInputFilePathName.Left(strInputFilePathName.GetLength()-4)+_T(".fpl"));
		}
	}
}

/*=============================================================================

=============================================================================*/

void CivexDlg::OnBnClickedButtonOutfile()
{
	// TODO: Add your control notification handler code here

	CString		strOutputFilePathName;

	m_wndEditCtrl_outfile.GetWindowText(strOutputFilePathName);
	CFileDialog	wndDlg(FALSE																/*									*/
					  ,_T(".fpl")															/*									*/
					  ,!strOutputFilePathName.IsEmpty() ? strOutputFilePathName:_T("*.fpl")	/*									*/
					  ,OFN_CREATEPROMPT														/*									*/
					  |OFN_OVERWRITEPROMPT													/*									*/
					  |OFN_HIDEREADONLY														/*									*/
					  |OFN_ENABLESIZING														/*									*/
					  |OFN_NOCHANGEDIR														/*									*/
					  |OFN_SHOWHELP															/*									*/
					  ,_T("Free PCB library files (*.fpl)|*.fpl|All Files (*.*)|*.*||")		/*									*/
					  ,this																	/*									*/ );
	if(wndDlg.DoModal()==IDOK)
	{
		m_wndEditCtrl_outfile.SetWindowText(wndDlg.GetPathName());
	}
}

/*=============================================================================

=============================================================================*/

void	CivexDlg::OnEnChangeEditInfile()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
}

/*=============================================================================

=============================================================================*/

void	CivexDlg::OnEnChangeEditOutfile()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
}

/*=============================================================================

=============================================================================*/

void	CivexDlg::OnBnClickedConvert()
{
	CStdioFile mod_file, lib_file;

	m_wndEditCtrl_infile.GetWindowText(m_strInputFilePathName);
	m_wndEditCtrl_outfile.GetWindowText(m_strOutputFilePathName);

	int err = mod_file.Open( m_strInputFilePathName, CFile::modeRead, NULL );
	if( !err )
	{
		// error opening file
		CString	strErrMsg;
		strErrMsg.Format(_T("Unable to open input file %s"), m_strInputFilePathName );
		AfxMessageBox(strErrMsg,MB_ICONWARNING|MB_OK);
		return;
	}
	err = lib_file.Open( m_strOutputFilePathName, CFile::modeWrite | CFile::modeCreate, NULL );
	if( !err )
	{
		// error opening file
		CString strErrMsg;
		strErrMsg.Format(_T("Unable to open output file %s"), m_strOutputFilePathName );
		AfxMessageBox(strErrMsg,MB_ICONWARNING|MB_OK);
		return;
	}
	CString str;

	str.Format(_T("Converting Ivex file %s...\r\n"), m_strInputFilePathName );
	m_wndEditCtrl_messages.ReplaceSel( str );
	err = ConvertIvex( &mod_file, &lib_file, &m_wndEditCtrl_messages );
	m_wndEditCtrl_messages.ReplaceSel(_T("done\r\n"));
	mod_file.Close();
	lib_file.Close();
}

/*=============================================================================

=============================================================================*/

void	CivexDlg::PumpMessages()
{
	// _CAOgpO Create() ĂłB

	ASSERT(m_hWnd!=NULL);

	MSG			msg;

	while(PeekMessage(&msg,NULL,0,0,PM_REMOVE))	/* _CAObZ[W	*/
	{
		if(!IsDialogMessage(&msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);  
		}
	}
}

/*=============================================================================

=============================================================================*/

int	 CALLBACK	CivexDlg::ConvertCallbackEntry(INT nLine,INT nBlock,LPVOID pObject) /* static */
{
		CivexDlg	*pDlg;

//	if(pObject)
	if(pObject && ((CObject *)pObject)->IsKindOf(RUNTIME_CLASS(CivexDlg)))
	{
		pDlg=(CivexDlg *)pObject;
//		ASSERT(pDlg->IsKindof(RUNTIME_CLASS(CPanelizeDlg)));

		ASSERT(pDlg->m_hWnd);
		return(pDlg->ConvertCallbackFunction(nLine,nBlock));
	}
	else
	{
		ASSERT(FALSE);					/* Debugp({ɂ͗Ȃ͂)	*/
		return(-1);
	}
}


/*=============================================================================

=============================================================================*/

int		CivexDlg::ConvertCallbackFunction(INT nLine,INT nBlock)
{
	ASSERT(m_hWnd);

	CString		strTemp;

	if(!nLine)
		m_wndProgressBar.SetRange32(nLine,nBlock);	// m_wndProgressBar ́ACSingleWorkerThreadDlg ̃Rg[^oϐ	*/
	m_wndProgressBar.SetPos(nLine);

	strTemp.Format(_T("%d/%d - (%d%%)"),nLine,nBlock,nLine*100/nBlock);
	SetDlgItemText(IDC_PROGRESS_STATUS,strTemp);
	PumpMessages();						/* yfBÕbZ[W̏	*/

//	return(IsAbortThread() ? -1:0);
	return(0);
}

/*------------------------------------------------------------------------------
							end of DlgIvex.cpp
------------------------------------------------------------------------------*/
