#pragma once
#include "FootprintLib.h"
#include "afxwin.h"


// CDlgLibraryManager dialog

// globals
static int m_page_sel = 0;
static int m_units_sel = 0;

/*=============================================================================
					CDlgLibraryManager _CAO NX̐錾
=============================================================================*/

class CDlgLibraryManager : public CDialog
{
	DECLARE_DYNAMIC(CDlgLibraryManager)
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
public:
	CDlgLibraryManager(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDlgLibraryManager();
	void Initialize(CFootLibFolderMap * foldermap);
//				   ,CDlgLog * log);
//--------------------------------------
// _CAO f[^(萔)
//--------------------------------------
protected:
	//{{AFX_DATA(CDlgLibraryManager)
	enum { IDD = IDD_LIB_MANAGER };
	//}}AFX_DATA

	enum { PG_LETTER, PG_A4 };
	enum { U_NATIVE, U_MM, U_MIL, U_MM_MIL };
//--------------------------------------
// Override(s) - yz֐z
//--------------------------------------
	//{{AFX_VIRTUAL(CDlgLibraryManager)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
//--------------------------------------
// _CAO f[^(ϐ)
//--------------------------------------
protected:
	CFootLibFolderMap * m_foldermap;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
public:
	CFootLibFolder	*m_footlib;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit			m_wndEditCtrl_footlib;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox		m_wndComboBox_libfile;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox		m_wndComboBox_page_size;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox		m_wndComboBox_units;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
//--------------------------------------
// Generated message map function(s)
//--------------------------------------
protected:
	//{{AFX_MSG(CDlgLibraryManager)
	afx_msg void OnBnClickedButtonMakePdf();
	afx_msg void OnBnClickedButtonMgrBrowse();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
/*-----------------------------------------------------------------------------
							end of DlgLibraryManager.h
-----------------------------------------------------------------------------*/
