// DlgLog.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgLog.h"
#include ".\dlglog.h"


// CDlgLog dialog

IMPLEMENT_DYNAMIC(CDlgLog, CDialog)

/*=============================================================================
						CDlgLog NX̍\z
=============================================================================*/

CDlgLog::CDlgLog(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgLog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgLog)
	//}}AFX_DATA_INIT

	m_running = TRUE;
}

/*=============================================================================
						CDlgLog NX̏
=============================================================================*/

CDlgLog::~CDlgLog()
{
}

/*=============================================================================
			CDlgLog _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgLog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgLog)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_EDIT_LOG, m_wndEditCtrl_log);
	if(!pDX->m_bSaveAndValidate)			/* ϐRg[	*/
	{
		// incoming
		m_wndEditCtrl_log.LimitText( 1000000 );
	}
}

/*=============================================================================
					CDlgLog NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgLog, CDialog)
	//{{AFX_MSG_MAP(CDlgLog)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_WM_SETCURSOR()
	ON_BN_CLICKED(ID_HIDE_ME, OnBnClickedHideMe)
END_MESSAGE_MAP()

/*=============================================================================

=============================================================================*/

BOOL CDlgLog::Create(CWnd* pParentWnd /*=NULL*/)
{
	return(CDialog::Create(IDD,pParentWnd));
}

/*=============================================================================

=============================================================================*/

void	CDlgLog::Move( int x, int y ) 
{
   CRect myRect;
   GetWindowRect(&myRect);
   myRect.OffsetRect( x, y );
   MoveWindow(myRect);
}

/*=============================================================================

=============================================================================*/

void	CDlgLog::Clear()
{
	// clear edit control
	m_wndEditCtrl_log.SetSel( 0, 999999 );
	m_wndEditCtrl_log.ReplaceSel(_T(""));
}

/*=============================================================================

=============================================================================*/

void	CDlgLog::AddLine( LPCTSTR str )
{
	m_wndEditCtrl_log.ReplaceSel( str );
}

// CDlgLog message handlers

/*=============================================================================

=============================================================================*/

void	CDlgLog::OnBnClickedOk()
{
	m_running = FALSE;
	CWnd * frm = ::AfxGetMainWnd();
	frm->BringWindowToTop();
	OnOK();
}

/*=============================================================================

=============================================================================*/

BOOL CDlgLog::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
	CMainFrame * frm = (CMainFrame*)AfxGetMainWnd();
	if( frm->m_bCursorHidden )
	{
		::ShowCursor( TRUE );
		frm->m_bCursorHidden = FALSE;
	}
//	return CDialog::OnSetCursor(pWnd, nHitTest, message);
	return TRUE;
}

/*=============================================================================

=============================================================================*/

void	CDlgLog::OnBnClickedHideMe()
{
	this->ShowWindow( SW_HIDE );
}
