#pragma once
#include "afxcmn.h"
#include "NetList.h"
#include "afxwin.h"


// CDlgNetlist dialog

/*=============================================================================
					CDlgNetlist _CAO NX̐錾
=============================================================================*/

class CDlgNetlist : public CDialog
{
	DECLARE_DYNAMIC(CDlgNetlist)
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
public:
	CDlgNetlist(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDlgNetlist();
	void Initialize( CNetList * nlist, CPartList * plist,CArray<int> * w, CArray<int> * v_w, CArray<int> * v_h_w ); 
private:
	void	DrawListCtrl();
//--------------------------------------
// _CAO f[^(萔)
//--------------------------------------
protected:
	//{{AFX_DATA(CDlgNetlist)
	enum { IDD = IDD_NET_LIST };
	//}}AFX_DATA
//--------------------------------------
// Override(s) - yz֐z
//--------------------------------------
	//{{AFX_VIRTUAL(CDlgNetlist)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

//--------------------------------------
// _CAO f[^(ϐ)
//--------------------------------------
public:
	int				m_visible_state;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_item_selected;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	netlist_info	*m_nl;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
protected:
	CNetList		*m_nlist;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CPartList		*m_plist;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CArray<int>		*m_w;						/**< array of default widths					*/
	CArray<int>		*m_v_w;						/**< array of via widths (matching m_w[] entries)	*/
	CArray<int>		*m_v_h_w;					/**< array of via hole widths					*/
private:
	int			m_sort_type;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CListCtrl	m_wndListCtrl;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndPushBtn_visible;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndPushBtn_delete_single;		/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndPushBtn_delete;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndPushBtn_edit;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndPushBtn_add;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndPushBtn_nl_width;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndPushBtn_select_all;		/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_OK;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_cancel;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
//--------------------------------------
// Generated message map function(s)
//--------------------------------------
protected:
	//{{AFX_MSG(CDlgNetlist)
	virtual BOOL OnInitDialog();
	afx_msg void OnLvnColumnclickListNet(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedButtonAdd();
	afx_msg void OnBnClickedButtonDelete();
	afx_msg void OnBnClickedButtonVisible();
	afx_msg void OnBnClickedButtonEdit();
	afx_msg void OnBnClickedButtonSelectAll();
	afx_msg void OnBnClickedButtonNLWidth();
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCancel();
	afx_msg void OnBnClickedDeleteNetsWithNoPins();
	afx_msg void OnNMClickListNet(NMHDR *pNMHDR, LRESULT *pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
/*-----------------------------------------------------------------------------
							end of DlgNetlist.h
-----------------------------------------------------------------------------*/
