// DlgRefText.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "PartList.h"
#include "DlgRefText.h"
#include ".\dlgreftext.h"


// CDlgRefText dialog

IMPLEMENT_DYNAMIC(CDlgRefText, CDialog)

/*=============================================================================
						CDlgRefText NX̍\z
=============================================================================*/

CDlgRefText::CDlgRefText(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgRefText::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgRefText)
	//}}AFX_DATA_INIT
	m_flgInitDlgEnd=FALSE;
}

/*=============================================================================
						CDlgRefText NX̏
=============================================================================*/

CDlgRefText::~CDlgRefText()
{
}

/*=============================================================================
			CDlgRefText _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgRefText::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgRefText)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_EDIT_REF_ID, m_wndEditCtrl_ref_des);
	DDX_Control(pDX, IDC_EDIT_CHAR_HEIGHT, m_wndEditCtrl_height);
	DDX_Control(pDX, IDC_COMBO_REF_TEXT_UNITS, m_wndComboBox_units);
	DDX_Control(pDX, IDC_RADIO_SET, m_wndRadioBtn_set);
	DDX_Control(pDX, IDC_RADIO_DEF, m_wndRadioBtn_def);
	DDX_Control(pDX, IDC_EDIT_WIDTH, m_wndEditCtrl_width);
	DDX_Control(pDX, IDC_EDIT_DEF_WIDTH, m_wndEditCtrl_def_width);
	DDX_Control(pDX, IDC_CHECK_VISIBLE, m_wndCheckBtn_visible);
	if(!pDX->m_bSaveAndValidate)			/* ϐRg[	*/
	{
		// entry
		m_wndEditCtrl_ref_des.EnableWindow( FALSE );
		m_wndEditCtrl_ref_des.SetWindowText( m_part->ref_des );
		m_wndComboBox_units.InsertString( 0, _T("MIL"));
		m_wndComboBox_units.InsertString( 1, _T("MM"));
		if( m_units == MIL )
			m_wndComboBox_units.SetCurSel( 0 );
		else
			m_wndComboBox_units.SetCurSel( 1 );
		if( m_width == m_height/10 )
		{
			m_wndRadioBtn_set.SetCheck( FALSE );
			m_wndRadioBtn_def.SetCheck( TRUE );
			m_wndEditCtrl_def_width.EnableWindow( FALSE );
			m_wndEditCtrl_width.EnableWindow( FALSE );
		}
		else
		{
			m_wndRadioBtn_set.SetCheck( TRUE );
			m_wndRadioBtn_def.SetCheck( FALSE );
			m_wndEditCtrl_def_width.EnableWindow( FALSE );
			m_wndEditCtrl_width.EnableWindow( TRUE );
		}
		SetFields();
	}
	else
	{
		// exit
		GetFields();
		if( m_wndRadioBtn_def.GetCheck() )
			m_width = m_def_width;
	}
}

/*=============================================================================

=============================================================================*/
// the calling program should call this to set up dialog
// and provide pointers to variables which will be modified

void CDlgRefText::Initialize(CPartList * plist							/**< ToDo:Add Comment for Doxygen			*/
							,cpart * part								/**< ToDo:Add Comment for Doxygen			*/
							,CMapStringToPtr * shape_cache_map			/**< ToDo:Add Comment for Doxygen			*/ )
{
	m_plist = plist;
	m_part = part;
	m_footprint_cache_map = shape_cache_map;
	m_vis = part->m_ref_vis;
	m_units = part->shape->m_units;
	m_width = m_part->m_ref_w;
	m_height = m_part->m_ref_size;
	m_def_width = m_height/10;
}

/*=============================================================================
				CDlgRefText NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgRefText, CDialog)
	//{{AFX_MSG_MAP(CDlgRefText)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_RADIO_SET, OnBnClickedRadioSet)
	ON_EN_CHANGE(IDC_EDIT_CHAR_HEIGHT, OnEnChangeEditCharHeight)
	ON_BN_CLICKED(IDC_RADIO_DEF, OnBnClickedRadioDef)
	ON_CBN_SELCHANGE(IDC_COMBO_REF_TEXT_UNITS, OnCbnSelchangeComboRefTextUnits)
END_MESSAGE_MAP()

// CDlgRefText message handlers

/*=============================================================================

=============================================================================*/

BOOL	CDlgRefText::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO :  ɏǉĂ

	m_flgInitDlgEnd=TRUE;

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

/*=============================================================================

=============================================================================*/

void	CDlgRefText::OnBnClickedRadioSet()
{
	m_wndEditCtrl_width.EnableWindow( TRUE );
}

/*=============================================================================

=============================================================================*/

void CDlgRefText::OnBnClickedRadioDef()
{
	m_wndEditCtrl_width.EnableWindow( FALSE );

}

/*=============================================================================

=============================================================================*/

void CDlgRefText::OnEnChangeEditCharHeight()
{
	if(!IsInitDlgEnd())
		return;

	CString str;
	m_wndEditCtrl_height.GetWindowText( str );
	if( m_units == MIL )
		m_height = _tstof( str ) * NM_PER_MIL;
	else
		m_height = _tstof( str ) * 1000000.0;
	m_def_width = m_height/10;
	if( m_def_width < 1*NM_PER_MIL )
		m_def_width = 1*NM_PER_MIL;
	if( m_units == MIL )
	{
		MakeCStringFromDouble( &str, m_def_width/NM_PER_MIL );
		m_wndEditCtrl_def_width.SetWindowText( str );
	}
	else
	{
		MakeCStringFromDouble( &str, m_def_width/1000000.0 );
		m_wndEditCtrl_def_width.SetWindowText( str );
	}
}

/*=============================================================================

=============================================================================*/

void CDlgRefText::GetFields()
{
	CString str;
	if( m_units == MIL )
	{
		m_wndEditCtrl_height.GetWindowText( str );
		m_height = _tstof( str ) * NM_PER_MIL;
		m_wndEditCtrl_width.GetWindowText( str );
		m_width = _tstof( str ) * NM_PER_MIL;
	}
	else
	{
		m_wndEditCtrl_height.GetWindowText( str );
		m_height = _tstof( str ) * 1000000.0;
		m_wndEditCtrl_width.GetWindowText( str );
		m_width = _tstof( str ) * 1000000.0;
	}
	m_def_width = m_height/10;
	m_vis = m_wndCheckBtn_visible.GetCheck();
}

/*=============================================================================

=============================================================================*/

void CDlgRefText::SetFields()
{
	CString str;
	if( m_units == MIL )
	{
		MakeCStringFromDouble( &str, m_height/NM_PER_MIL );
		m_wndEditCtrl_height.SetWindowText( str );
		MakeCStringFromDouble( &str, m_width/NM_PER_MIL );
		m_wndEditCtrl_width.SetWindowText( str );
		MakeCStringFromDouble( &str, m_def_width/NM_PER_MIL );
		m_wndEditCtrl_def_width.SetWindowText( str );
	}
	else
	{
		MakeCStringFromDouble( &str, m_height/1000000.0 );
		m_wndEditCtrl_height.SetWindowText( str );
		MakeCStringFromDouble( &str, m_width/1000000.0 );
		m_wndEditCtrl_width.SetWindowText( str );
		MakeCStringFromDouble( &str, m_def_width/1000000.0 );
		m_wndEditCtrl_def_width.SetWindowText( str );
	}
	m_wndCheckBtn_visible.SetCheck( m_vis );
}

/*=============================================================================

=============================================================================*/

void CDlgRefText::OnCbnSelchangeComboRefTextUnits()
{
	GetFields();
	if( m_wndComboBox_units.GetCurSel() == 0 )
		m_units = MIL;
	else
		m_units = MM;
	SetFields();
}

/*-----------------------------------------------------------------------------
							end of DlgRefText.cpp
-----------------------------------------------------------------------------*/
