#pragma once
#include "afxwin.h"
#include "FreePcbDoc.h"


// CDlgReport dialog

/*=============================================================================
					CDlgReport _CAO NX̐錾
=============================================================================*/

class CDlgReport : public CDialog
{
	DECLARE_DYNAMIC(CDlgReport)
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
public:
	CDlgReport(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDlgReport();
	void Initialize( CFreePcbDoc * doc );
//--------------------------------------
// _CAO f[^(萔)
//--------------------------------------
protected:
	//{{AFX_DATA(CDlgReport)
	enum { IDD = IDD_REPORT };
	//}}AFX_DATA
public:
	enum{ NO_PCB_STATS = 0x1,
		  NO_DRILL_LIST = 0x2,
		  NO_PARTS_LIST = 0x4,
		  NO_CAM_PARAMS = 0x8,
		  NO_DRC_PARAMS = 0x10,
		  DRC_LIST = 0x20,
		  CONNECTIVITY_LIST = 0x40,
		  USE_MM = 0x1000,
		  CW = 0x2000,
		  TOP = 0x4000
	};

//--------------------------------------
// Override(s) - yz֐z
//--------------------------------------
	//{{AFX_VIRTUAL(CDlgReport)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

public:
	CFreePcbDoc	* m_doc;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CPartList	* m_pl;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CNetList	* m_nl;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_flags;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_units;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_top;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_ccw;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
private:
	CButton		m_wndRadioBtn_top;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_ccw;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_board;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_drill;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_parts;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_cam;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_drc_params;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_drc;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_connectivity;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_inch;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_mm;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
//--------------------------------------
// Generated message map function(s)
//--------------------------------------
protected:
	//{{AFX_MSG(CDlgReport)
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
/*-----------------------------------------------------------------------------
							end of DlgReport.h
-----------------------------------------------------------------------------*/
