#pragma once
#include "afxwin.h"


// CDlgSaveFootprint dialog

/*=============================================================================
				CDlgSaveFootprint _CAO NX̐錾
=============================================================================*/

class CDlgSaveFootprint : public CDialog
{
	DECLARE_DYNAMIC(CDlgSaveFootprint)
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
public:
	CDlgSaveFootprint(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDlgSaveFootprint();
	void Initialize(CString * name
				   ,CShape * footprint
				   ,int units
				   ,LPCTSTR default_file_name
				   ,CMapStringToPtr * shape_cache_map
				   ,CFootLibFolderMap * footlibfoldermap);
	void InitFileList();
//--------------------------------------
// _CAO f[^(萔)
//--------------------------------------
protected:
	//{{AFX_DATA(CDlgSaveFootprint)
	enum { IDD = IDD_SAVE_FOOTPRINT };
	//}}AFX_DATA
//--------------------------------------
// _CAO f[^(ϐ)
//--------------------------------------
protected:
	int m_lib_user;		// index to "user_created.flb"
	int m_lib_last;		// index to last file saved
//--------------------------------------
// Override(s) - yz֐z
//--------------------------------------
	//{{AFX_VIRTUAL(CDlgSaveFootprint)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

public:
	CMapStringToPtr *	m_footprint_cache_map;		/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CFootLibFolderMap *	m_foldermap;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CFootLibFolder *	m_folder;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CShape *			m_footprint;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int					m_units;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CString				m_default_filename;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CString				m_folder_name;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CString				m_name;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CString				m_author;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CString				m_source;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CString				m_desc;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
private:
	CStatic		m_preview;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_name;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox	m_wndComboBox_lib;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_source;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_author;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_desc;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_folder;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CStatic		m_static_units;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
//--------------------------------------
// Generated message map function(s)
//--------------------------------------
protected:
	//{{AFX_MSG(CDlgSaveFootprint)
	afx_msg void OnCbnSelchangeComboLibs();
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedButtonBrowse();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
/*-----------------------------------------------------------------------------
							end of DlgSaveFootprint.h
-----------------------------------------------------------------------------*/
