#pragma once
#include "afxwin.h"
#include "afxtempl.h"


// DlgSetSegmentWidth dialog

/*=============================================================================
				DlgSetSegmentWidth _CAO NX̐錾
=============================================================================*/

class DlgSetSegmentWidth : public CDialog
{
	DECLARE_DYNAMIC(DlgSetSegmentWidth)
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
public:
	DlgSetSegmentWidth(CWnd* pParent = NULL);   // standard constructor
	virtual ~DlgSetSegmentWidth();
//--------------------------------------
// _CAO f[^(萔)
//--------------------------------------
protected:
	//{{AFX_DATA(DlgSetSegmentWidth)
	enum { IDD = IDD_SEGMENT_WIDTH };
	//}}AFX_DATA
//--------------------------------------
// Override(s) - yz֐z
//--------------------------------------
	//{{AFX_VIRTUAL(DlgSetSegmentWidth)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

public:
	// these variables should be set on entry
	int			m_mode;							/**< 0=segment, 1=connection, 2=net					*/
	int			m_init_w;						/**< initial value for width						*/
	int			m_init_via_w;					/**< initial value for via_w						*/
	int			m_init_via_hole_w;				/**< initial value for via_hole_w					*/
	CArray<int>	*m_w;							/**< array of default widths						*/
	CArray<int>	*m_v_w;							/**< array of via widths (matching m_w[] entries)	*/
	CArray<int>	*m_v_h_w;						/**< array of via hole widths						*/

	// these variables will be set on exit
	int			m_tv;							/**< 1=traces and vias, 2=traces only, 3=vias only	*/
	int			m_def;							/**< set default width (1=con, 2=net)				*/
	int			m_apply;						/**< apply width (1=seg, 2=con, 3=net)				*/
	int			m_width;						/**< trace width									*/
	int			m_via_width;					/**< trace width									*/
	int			m_hole_width;					/**< trace width									*/
private:
	CButton		m_def_net;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_apply_net;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_apply_con;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_apply_seg;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox	m_width_box;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CString		m_width_str;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CString		m_via_w_str;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CString		m_via_hole_w_str;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_via_w;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_via_hole_w;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		rb_set_via;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		rb_def_via;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_mod_tv;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_mod_t;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_mod_v;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
//--------------------------------------
// Generated message map function(s)
//--------------------------------------
protected:
	//{{AFX_MSG(DlgSetSegmentWidth)
	virtual BOOL OnInitDialog();
	afx_msg void OnBnClickedDefNet();
	afx_msg void OnBnClickedApplyNet();
	afx_msg void OnBnClickedApplyCon();
	afx_msg void OnBnClickedApplySeg();
	afx_msg void OnBnClickedRadioDefVia();
	afx_msg void OnBnClickedRadioSetVia();
	afx_msg void OnCbnSelchangeComboWidth();
	afx_msg void OnCbnEditchangeComboWidth();
	afx_msg void OnBnClickedRadioModTv();
	afx_msg void OnBnClickedRadioModT();
	afx_msg void OnBnClickedRadioModV();
	afx_msg void OnBnClickedRadioModify();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
/*-----------------------------------------------------------------------------
							end of DlgSetSegmentWidth.h
-----------------------------------------------------------------------------*/
