// DlgSlot.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgSlot.h"

// defines
enum
{
	 POS_DEFAULT					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,POS_DEFINED					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,POS_DRAG						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
};

// CDlgSlot dialog

IMPLEMENT_DYNAMIC(CDlgSlot, CDialog)

/*=============================================================================
						CDlgSlot NX̍\z
=============================================================================*/

CDlgSlot::CDlgSlot(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgSlot::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgSlot)
	//}}AFX_DATA_INIT
}

/*=============================================================================
						CDlgSlot NX̏
=============================================================================*/

CDlgSlot::~CDlgSlot()
{
}

/*=============================================================================
			CDlgSlot _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgSlot::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgSlot)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_RADIO2, m_wndRadioBtn_set);
	DDX_Control(pDX, IDC_RADIO1, m_wndRadioBtn_drag);
	DDX_Control(pDX, IDC_RADIO5, m_wndRadioBtn_plated);
	DDX_Control(pDX, IDC_RADIO6, m_wndRadioBtn_unplated);
	DDX_Control(pDX, IDC_COMBO1, m_wndComboBox_units);
	DDX_Control(pDX, IDC_EDIT1, m_wndEditCtrl_x);
	DDX_Control(pDX, IDC_EDIT2, m_wndEditCtrl_y);
	DDX_Control(pDX, IDC_EDIT_DIAMETER, m_wndEditCtrl_w);
	DDX_Control(pDX, IDC_EDIT_TRAVEL, m_wndEditCtrl_travel);
	DDX_Control(pDX, IDC_COMBO_DIRECTION, m_wndComboBox_direction);
	if(!pDX->m_bSaveAndValidate)			/* ϐRg[	*/
	{
		// incoming
		m_wndComboBox_units.InsertString( 0,_T("MIL"));
		m_wndComboBox_units.InsertString( 1,_T("MM"));
		m_wndComboBox_direction.InsertString( 0,_T("RIGHT"));
		m_wndComboBox_direction.InsertString( 1,_T("DOWN"));
		m_wndComboBox_direction.InsertString( 2,_T("LEFT"));
		m_wndComboBox_direction.InsertString( 3,_T("UP"));
		SetFields();
	}
	else
	{
		// outgoing
		GetFields();
	}
}

/*=============================================================================
					CDlgSlot NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgSlot, CDialog)
	//{{AFX_MSG_MAP(CDlgSlot)
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(IDC_COMBO1, OnCbnSelChangeCombo1)
	ON_BN_CLICKED(IDC_RADIO2, OnBnClickedSet)
	ON_BN_CLICKED(IDC_RADIO1, OnBnClickedDrag)
	ON_BN_CLICKED(IDC_RADIO5, OnBnClickedPlated)
	ON_BN_CLICKED(IDC_RADIO6, OnBnClickedUnplated)
END_MESSAGE_MAP()

/*=============================================================================

=============================================================================*/

void	CDlgSlot::Initialize(int units				/**< ToDo:Add Comment for Doxygen			*/
							,int w					/**< ToDo:Add Comment for Doxygen			*/
							,int travel				/**< ToDo:Add Comment for Doxygen			*/
							,int dir				/**< ToDo:Add Comment for Doxygen			*/
							,int x					/**< ToDo:Add Comment for Doxygen			*/
							,int y					/**< ToDo:Add Comment for Doxygen			*/
							,BOOL bPlated			/**< ToDo:Add Comment for Doxygen			*/
							,BOOL bDrag				/**< ToDo:Add Comment for Doxygen			*/ )
{
	m_bDrag =  bDrag;
	m_bPlated =  bPlated;
	m_units = units;
	m_w = w;
	m_travel = travel;
	m_dir = dir;
	m_x = x;
	m_y = y;
}

/*=============================================================================

=============================================================================*/

void	CDlgSlot::SetFields()
{
	CString str;
	m_wndRadioBtn_plated.SetCheck( m_bPlated );
	m_wndRadioBtn_unplated.SetCheck( !m_bPlated );
	m_wndRadioBtn_set.SetCheck( !m_bDrag );
	m_wndRadioBtn_drag.SetCheck( m_bDrag );
	m_wndEditCtrl_x.EnableWindow( !m_bDrag );
	m_wndEditCtrl_y.EnableWindow( !m_bDrag );
	m_wndComboBox_direction.SetCurSel( m_dir/90 );
	if( m_units == MIL ) 
		m_wndComboBox_units.SetCurSel( 0 );
	else
		m_wndComboBox_units.SetCurSel( 1 );
	::MakeCStringFromDimension( &str, m_w, m_units, FALSE, FALSE, FALSE, 3 );
	m_wndEditCtrl_w.SetWindowText( str );
	::MakeCStringFromDimension( &str, m_travel, m_units, FALSE, FALSE, FALSE, 3 );
	m_wndEditCtrl_travel.SetWindowText( str );
	::MakeCStringFromDimension( &str, m_x, m_units, FALSE, FALSE, FALSE, 3 );
	m_wndEditCtrl_x.SetWindowText( str );
	::MakeCStringFromDimension( &str, m_y, m_units, FALSE, FALSE, FALSE, 3 );
	m_wndEditCtrl_y.SetWindowText( str );
}

/*=============================================================================

=============================================================================*/

void	CDlgSlot::GetFields()
{
	CString str;
	m_bDrag = m_wndRadioBtn_drag.GetCheck();
	m_bPlated = m_wndRadioBtn_plated.GetCheck();
	m_dir = m_wndComboBox_direction.GetCurSel() * 90;
	m_wndEditCtrl_w.GetWindowText( str );
	m_w = ::GetDimensionFromString( str, m_units );
	m_wndEditCtrl_travel.GetWindowText( str );
	m_travel = ::GetDimensionFromString( str, m_units );
	m_wndEditCtrl_x.GetWindowText( str );
	m_x = ::GetDimensionFromString( str, m_units );
	m_wndEditCtrl_y.GetWindowText( str );
	m_y = ::GetDimensionFromString( str, m_units );
}

// CDlgSlot message handlers

/*=============================================================================

=============================================================================*/

void	CDlgSlot::OnCbnSelChangeCombo1()
{
	GetFields();
	int m_sel_units = m_wndComboBox_units.GetCurSel();
	if( m_sel_units == 0 )
		m_units = MIL;
	else
		m_units = MM;
	SetFields();
}

/*=============================================================================

=============================================================================*/

void	CDlgSlot::OnBnClickedSet()
{
	GetFields();
	SetFields();
}

/*=============================================================================

=============================================================================*/

void	CDlgSlot::OnBnClickedDrag()
{
	GetFields();
	SetFields();
}

/*=============================================================================

=============================================================================*/

void	CDlgSlot::OnBnClickedPlated()
{
	GetFields();
	SetFields();
}

/*=============================================================================

=============================================================================*/

void	CDlgSlot::OnBnClickedUnplated()
{
	GetFields();
	SetFields();
}

