#pragma once
#include "afxwin.h"


// CDlgWizQuad dialog

/*=============================================================================
					CDlgWizQuad _CAO NX̐錾
=============================================================================*/

class CDlgWizQuad : public CDialog
{
	DECLARE_DYNAMIC(CDlgWizQuad)
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
public:
	CDlgWizQuad(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDlgWizQuad();
	void Initialize(CMapStringToPtr * shape_cache_map
				   ,CFootLibFolderMap * footlibfoldermap 
				   ,BOOL enable_save);
	BOOL MakeFootprint();
//--------------------------------------
// _CAO f[^(萔)
//--------------------------------------
protected:
	//{{AFX_DATA(CDlgWizQuad)
	enum { IDD = IDD_WIZ_QUAD };
	//}}AFX_DATA
private:
	enum{ ROUND, SQUARE, SQ1, OCTAGON, RECT, RRECT, OVAL, NONE };
	enum{ TOP_CENTER, BOTTOM_LEFT, TOP_LEFT };
	enum{ SIP, DIP, QUAD, HDR1, HDR2, BGA, EDGE, EDGE2 };
//--------------------------------------
// _CAO f[^(ϐ)
//--------------------------------------
public:
	CShape		m_footprint;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CString		m_str_name;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_units;						// dimensional units (MM or MIL)
protected:
	CMapStringToPtr * m_footprint_cache_map;	/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CFootLibFolderMap * m_footlibfoldermap;		/**< ToDo:Describe short comment, about this member variable for Doxygen			*/

	BOOL		m_enable_save;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_type;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_shape;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_mult;							/**< multiplication factor (nm per unit)		*/
	int			m_pin1;							/**< position of pin 1							*/
	int			m_npins;						/**< total number of pins						*/
	int			m_hpins;						/**< pins per horiz. row						*/
	int			m_vpins;						/**< pins per vert. row							*/
	int			m_hd;							/**< hole diameter (0 for SMT)					*/
	int			m_x;							/**< all dimensions are in nanometers			*/
	int			m_y;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_r;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_e;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_c1;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_g1;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_z1;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_c2;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_g2;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_z2;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CStatic		m_bmp_quad;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CBitmap		m_bmp;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_C1;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_G1;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_Z1;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_C2;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_G2;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_Z2;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_C1;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_G1;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_Z1;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_C2;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_G2;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_Z2;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_E;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox	m_wndComboBox_shape;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox	m_wndComboBox_units;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox	m_wndComboBox_type;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox	m_wndComboBox_pin1;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_y;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_hd;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_x;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_npins;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_hpins;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_vpins;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_name;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_radius;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndPushBtn_save;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndPushBtn_exit;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndPushBtn_preview;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CStatic		m_preview;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
protected:
	BOOL		m_flgInitDlgEnd;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
//--------------------------------------
// Attribute(s) - yz
//--------------------------------------
public:
	BOOL		IsInitDlgEnd() const { return(m_flgInitDlgEnd); }
//--------------------------------------
// Override(s) - yz֐z
//--------------------------------------
	//{{AFX_VIRTUAL(CDlgWizQuad)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support 
	//}}AFX_VIRTUAL


	void FormatDimensionString( CString * str, int dim, int units );
	void ReviseDependentVariables();

//--------------------------------------
// Generated message map function(s)
//--------------------------------------
protected:
	//{{AFX_MSG(CDlgWizQuad)
	virtual BOOL OnInitDialog();
	afx_msg void OnBnClickedRadioC1();
	afx_msg void OnBnClickedRadioG1();
	afx_msg void OnBnClickedRadioZ1();
	afx_msg void OnBnClickedRadioC2();
	afx_msg void OnBnClickedRadioG2();
	afx_msg void OnBnClickedRadioZ2();
	afx_msg void OnCbnSelchangeComboWizShape();
	afx_msg void OnEnChangeEditWizNpins();
	afx_msg void OnEnChangeEditWizHpins();
	afx_msg void OnEnChangeEditWizX();
	afx_msg void OnEnChangeEditWizY();
	afx_msg void OnEnChangeEditWizR();
	afx_msg void OnEnChangeEditE();
	afx_msg void OnEnChangeEditC1();
	afx_msg void OnEnChangeEditG1();
	afx_msg void OnEnChangeEditZ1();
	afx_msg void OnEnChangeEditC2();
	afx_msg void OnEnChangeEditG2();
	afx_msg void OnEnChangeEditZ2();
	afx_msg void OnCbnSelchangeComboWizType();
	afx_msg void OnCbnSelchangeComboWizUnits();
	afx_msg void OnBnClickedButtonSave();
	afx_msg void OnCbnSelchangeComboPin1();
	afx_msg void OnEnChangeEditWizHd();
	afx_msg void OnBnClickedWizButtonExit();
	afx_msg void OnBnClickedButton2();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
/*-----------------------------------------------------------------------------
						end of DlgWizQuad.h
-----------------------------------------------------------------------------*/
