// MyFileDialog.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "MyFileDialog.h"


// CMyFileDialog

IMPLEMENT_DYNAMIC(CMyFileDialog, CFileDialog)

/*=============================================================================
						CMyFileDialog NX̍\z
=============================================================================*/

CMyFileDialog::CMyFileDialog(BOOL bOpenFileDialog, LPCTSTR lpszDefExt, LPCTSTR lpszFileName,
		DWORD dwFlags, LPCTSTR lpszFilter, CWnd* pParentWnd, DWORD dsize) :
		CFileDialog(bOpenFileDialog, lpszDefExt, lpszFileName, dwFlags, lpszFilter, pParentWnd, dsize)
{
}

/*=============================================================================
						CMyFileDialog NX̏
=============================================================================*/

CMyFileDialog::~CMyFileDialog()
{
}

/*=============================================================================
			CMyFileDialog _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CMyFileDialog::DoDataExchange(CDataExchange* pDX)
{
	// note: for some reason, this is not called on exit, use OnFileNameOK() instead
	CFileDialog::DoDataExchange(pDX);
	DDX_Control( pDX, IDC_RADIO_PARTS, m_wndRadioBtn_parts );
	DDX_Control( pDX, IDC_RADIO_NETS, m_wndRadioBtn_nets );
	DDX_Control( pDX, IDC_RADIO_PARTSANDNETS, m_wndRadioBtn_parts_and_nets );
	DDX_Control( pDX, IDC_RADIO_PADSPCB, m_wndRadioBtn_padspcb );
	DDX_Control( pDX, IDC_RADIO_FREEPCB, m_wndRadioBtn_freepcb );
	if(!pDX->m_bSaveAndValidate)			/* ϐRg[	*/
	{
		// on entry
		if( (m_flags & IMPORT_PARTS) && (m_flags & IMPORT_NETS) )
			m_wndRadioBtn_parts_and_nets.SetCheck( TRUE );
		else if( m_flags & IMPORT_NETS )
			m_wndRadioBtn_nets.SetCheck( TRUE );
		else
			m_wndRadioBtn_parts.SetCheck( TRUE );
		m_wndRadioBtn_padspcb.SetCheck( TRUE );
	}
}

/*=============================================================================
					CMyFileDialog _CAȌ
=============================================================================*/

BOOL	CMyFileDialog::OnInitDialog()
{
	CFileDialog::OnInitDialog(); //Call base class method first
	return TRUE;
}

void CMyFileDialog::Initialize( int flags			/**< ToDo:Add Comment for Doxygen			*/ )
{
	m_flags = flags;
}

BOOL CMyFileDialog::OnFileNameOK()
{
	// on exit
	m_flags &= ~IMPORT_PARTS;
	m_flags &= ~IMPORT_NETS;
	if( m_wndRadioBtn_parts.GetCheck() || m_wndRadioBtn_parts_and_nets.GetCheck() )
		m_flags |= IMPORT_PARTS;
	if( m_wndRadioBtn_nets.GetCheck() || m_wndRadioBtn_parts_and_nets.GetCheck() )
		m_flags |= IMPORT_NETS;

	if( m_wndRadioBtn_padspcb.GetCheck() )
		m_format = PADSPCB;

	return FALSE;
}

/*=============================================================================
					NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CMyFileDialog, CFileDialog)
	//{{AFX_MSG_MAP(CMyFileDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CMyFileDialog message handlers

