// MyFileDialog.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "MyFileDialogExport.h"


// CMyFileDialogExport

IMPLEMENT_DYNAMIC(CMyFileDialogExport, CFileDialog)

/*=============================================================================
					CMyFileDialogExport NX̍\z
=============================================================================*/

CMyFileDialogExport::CMyFileDialogExport(BOOL bOpenFileDialog, LPCTSTR lpszDefExt, LPCTSTR lpszFileName,
		DWORD dwFlags, LPCTSTR lpszFilter, CWnd* pParentWnd, DWORD dsize) :
		CFileDialog(bOpenFileDialog, lpszDefExt, lpszFileName, dwFlags, lpszFilter, pParentWnd, dsize)
{
}

/*=============================================================================
					CMyFileDialogExport NX̏
=============================================================================*/

CMyFileDialogExport::~CMyFileDialogExport()
{
}

/*=============================================================================
			CMyFileDialogExport _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CMyFileDialogExport::DoDataExchange(CDataExchange* pDX)
{
	// note: for some reason, this is not called on exit, use OnFileNameOK() instead
	CFileDialog::DoDataExchange(pDX);
	DDX_Control( pDX, IDC_RADIO_PARTS, m_wndRadioBtn_parts );
	DDX_Control( pDX, IDC_RADIO_NETS, m_wndRadioBtn_nets );
	DDX_Control( pDX, IDC_RADIO_PARTSANDNETS, m_wndRadioBtn_parts_and_nets );
	DDX_Control( pDX, IDC_RADIO_PADSPCB, m_wndRadioBtn_padspcb );
	DDX_Control( pDX, IDC_RADIO_FREEPCB, m_wndRadioBtn_freepcb );
	DDX_Control( pDX, IDC_CHECK_AT, m_wndCheckBtn_values );
	if(!pDX->m_bSaveAndValidate)			/* ϐRg[	*/
	{
		// on entry, set controls from member variables
		if( m_select & EXPORT_PARTS && m_select & EXPORT_NETS )
			m_wndRadioBtn_parts_and_nets.SetCheck( TRUE );
		else if( m_select & EXPORT_PARTS )
			m_wndRadioBtn_parts.SetCheck( TRUE );
		else if( m_select & EXPORT_NETS )
			m_wndRadioBtn_nets.SetCheck( TRUE );
		m_wndCheckBtn_values.SetCheck( m_select &  EXPORT_VALUES );
		m_wndRadioBtn_padspcb.SetCheck( TRUE );
	}
}

// Initialize dialog settings:
//	select = 0 for parts, 1 for nets, 2 for both
//	at_flag = TRUE to use "value@footprint" format for parts
//
void CMyFileDialogExport::Initialize( int select			/**< ToDo:Add Comment for Doxygen			*/ )
{
	m_select = select;
}

#if 0
/*=============================================================================
					_CAȌ
=============================================================================*/

BOOL	CMyFileDialogExport::OnInitDialog()
{
	CFileDialog::OnInitDialog(); //Call base class method first
	return TRUE;
}
#endif

BOOL CMyFileDialogExport::OnFileNameOK()
{
	// on exit, set member variables
	if( m_wndRadioBtn_parts.GetCheck() )
		m_select = EXPORT_PARTS;
	else if( m_wndRadioBtn_nets.GetCheck() )
		m_select = EXPORT_NETS;
	else
		m_select = EXPORT_PARTS | EXPORT_NETS;
	if( m_wndCheckBtn_values.GetCheck() )
		m_select |= EXPORT_VALUES;
	if( m_wndRadioBtn_padspcb.GetCheck() )
		m_format = PADSPCB;

	return FALSE;
}

/*=============================================================================
					NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CMyFileDialogExport, CFileDialog)
	//{{AFX_MSG_MAP(CMyFileDialogExport)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CMyFileDialogExport message handlers

