// MyToolBar.cpp : implementation file
//

#include	"stdafx.h"
#include	"MyToolBar.h"
#include	"math.h"

//#define IDC_COMBO_VISIBLE_GRID 2000
#define COMBO_W 100
#define COMBO_H 100

#define POS_COMBO_VISIBLE_GRID 11

extern CFreePcbApp theApp;

// CMyToolBar

IMPLEMENT_DYNAMIC(CMyToolBar, CToolBar)

/*=============================================================================
						CMyToolBar NX̍\z
=============================================================================*/

CMyToolBar::CMyToolBar()
{
	m_last_vg = -1;
}

/*=============================================================================
						CMyToolBar NX̏
=============================================================================*/

CMyToolBar::~CMyToolBar()
{
}

/*=============================================================================
					NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CMyToolBar, CToolBar)
	//{{AFX_MSG_MAP(CMyToolBar)
	//}}AFX_MSG_MAP
	ON_WM_NCPAINT()
	ON_WM_CREATE()
	ON_CBN_SELENDOK( IDC_COMBO_VISIBLE_GRID, OnSelectVisibleGrid )
	ON_CBN_SELENDOK( IDC_COMBO_PLACEMENT_GRID, OnSelectPlacementGrid )
	ON_CBN_SELENDOK( IDC_COMBO_ROUTING_GRID, OnSelectRoutingGrid )
	ON_CBN_SELENDOK( IDC_COMBO_SNAP_ANGLE, OnSelectSnapAngle )
	ON_CBN_SELENDOK( IDC_COMBO_UNITS, OnSelectUnits )
END_MESSAGE_MAP()



// CMyToolBar message handlers

/*=============================================================================

=============================================================================*/

int		CMyToolBar::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CToolBar::OnCreate(lpCreateStruct) == -1)
		return -1;

	if( !LoadToolBar( IDR_MYTOOLBAR ) )
		return -1;

#if(0)
	CImageList	*pImageList;
	int			nBtnCnt;

	pImageList=GetToolBarCtrl().GetImageList();		// c[o[̃C[WXg
	ASSERT(pImageList);
	pImageList->DeleteImageList();

	nBtnCnt=GetToolBarCtrl().GetButtonCount();
	pImageList->Create(16,16,ILC_COLOR24|ILC_MASK,nBtnCnt,nBtnCnt);
	m_gdiToolBarImage256.Create(IDR_MAINFRAME256,16,8, RGB(255,0,0));
	pImageList=GetToolBarCtrl().SetImageList(&m_gdiToolBarImage256);		// CToolBarCtrlrbg}bvǉ
	GetToolBarCtrl().AddBitmap(nBtnCnt,IDR_MAINFRAME256);					// 256FC[W
#endif

	SetButtonInfo( 12, IDC_STATIC_VISIBLE_GRID, TBBS_SEPARATOR, 40 );
	SetButtonInfo( 13, IDC_STATIC_VISIBLE_GRID, TBBS_SEPARATOR, 50 );
	SetButtonInfo( 14, IDC_STATIC_VISIBLE_GRID, TBBS_SEPARATOR, 80 );
	SetButtonInfo( 15, IDC_COMBO_VISIBLE_GRID, TBBS_SEPARATOR, 70 );
	SetButtonInfo( 16, IDC_STATIC_PLACEMENT_GRID, TBBS_SEPARATOR, 64 );
	SetButtonInfo( 17, IDC_COMBO_PLACEMENT_GRID, TBBS_SEPARATOR, 70 );
	SetButtonInfo( 18, IDC_STATIC_ROUTING_GRID, TBBS_SEPARATOR, 50 );
	SetButtonInfo( 19, IDC_COMBO_ROUTING_GRID, TBBS_SEPARATOR, 70 );
	SetButtonInfo( 20, IDC_STATIC_SNAP_ANGLE, TBBS_SEPARATOR, 50 );
	SetButtonInfo( 21, IDC_COMBO_SNAP_ANGLE, TBBS_SEPARATOR, 50 );

	m_font.CreateFont( 14, 0, 0, 0, FW_NORMAL, 0, 0, 0, DEFAULT_CHARSET,
		OUT_CHARACTER_PRECIS, CLIP_CHARACTER_PRECIS, DEFAULT_QUALITY, 
		DEFAULT_PITCH | FF_DONTCARE,_T("Arial"));
	SetFont( &m_font );

	CRect rect;
	GetItemRect( 12, &rect );
	rect.top += 5;
	rect.left += 5;
	m_ctlStaticUnits.Create(_T("   Units"), WS_VISIBLE, rect, this, IDC_STATIC_VISIBLE_GRID );
	m_ctlStaticUnits.SetFont( &m_font );

	GetItemRect( 13, &rect );
	rect.bottom = rect.top + 300;
	m_ctlComboUnits.Create( WS_CHILD | WS_VISIBLE | WS_VSCROLL |
		CBS_DROPDOWNLIST, rect, this, IDC_COMBO_UNITS );
	m_ctlComboUnits.SetFont( &m_font );

	m_ctlComboUnits.InsertString( 0,_T("mil"));
	m_ctlComboUnits.InsertString( 1,_T("mm"));
	m_ctlComboUnits.SetCurSel( 0 );

	GetItemRect( 14, &rect );
	rect.top += 5;
	rect.left += 5;
	m_ctlStaticVisibleGrid.Create(_T("   Grids: Visible"), WS_VISIBLE, rect, this, IDC_STATIC_VISIBLE_GRID );
	m_ctlStaticVisibleGrid.SetFont( &m_font );

	GetItemRect( 15, &rect );
	rect.bottom = rect.top + 300;
	m_ctlComboVisibleGrid.Create( WS_CHILD | WS_VISIBLE | WS_VSCROLL |
		CBS_DROPDOWNLIST, rect, this, IDC_COMBO_VISIBLE_GRID );
	m_ctlComboVisibleGrid.SetFont( &m_font );

	GetItemRect( 16, &rect );
	rect.top += 5;
	rect.left += 5;
	m_ctlStaticPlacementGrid.Create(_T("  Placement"), WS_VISIBLE, rect, this, IDC_STATIC_PLACEMENT_GRID );
	m_ctlStaticPlacementGrid.SetFont( &m_font );

	GetItemRect( 17, &rect );
	rect.bottom = rect.top + 300;
	m_ctlComboPlacementGrid.Create( WS_CHILD | WS_VISIBLE | WS_VSCROLL |
		CBS_DROPDOWNLIST, rect, this, IDC_COMBO_PLACEMENT_GRID );
	m_ctlComboPlacementGrid.SetFont( &m_font );

	GetItemRect( 18, &rect );
	rect.top += 5;
	rect.left += 5;
	m_ctlStaticRoutingGrid.Create(_T("  Routing"), WS_VISIBLE, rect, this, IDC_STATIC_ROUTING_GRID );
	m_ctlStaticRoutingGrid.SetFont( &m_font );

	GetItemRect( 19, &rect );
	rect.bottom = rect.top + 300;
	m_ctlComboRoutingGrid.Create( WS_CHILD | WS_VISIBLE | WS_VSCROLL |
		CBS_DROPDOWNLIST, rect, this, IDC_COMBO_ROUTING_GRID );
	m_ctlComboRoutingGrid.SetFont( &m_font );

	GetItemRect( 20, &rect );
	rect.top += 5;
	rect.left += 5;
	m_ctlStaticSnapAngle.Create(_T("  Angle"), WS_VISIBLE, rect, this, IDC_STATIC_SNAP_ANGLE );
	m_ctlStaticSnapAngle.SetFont( &m_font );

	GetItemRect( 21, &rect );
	rect.bottom = rect.top + 300;
	m_ctlComboSnapAngle.Create( WS_CHILD | WS_VISIBLE | WS_VSCROLL |
		CBS_DROPDOWNLIST, rect, this, IDC_COMBO_SNAP_ANGLE );
	m_ctlComboSnapAngle.SetFont( &m_font );

	return 0;
}

/*=============================================================================

=============================================================================*/

void	CMyToolBar::SetLists(CArray<double> * visible
							,CArray<double> * placement
							,CArray<double> * routing
							,double vg
							,double pg
							,double rg
							,int ag
							,int units )
{
	if( units == NM || units == MM )
		m_ctlComboUnits.SetCurSel(1);
	else
		m_ctlComboUnits.SetCurSel(0);
	m_v = visible;
	m_p = placement;
	m_r = routing;
	m_ctlComboVisibleGrid.ResetContent();
	m_ctlComboPlacementGrid.ResetContent();
	m_ctlComboRoutingGrid.ResetContent();
	m_ctlComboSnapAngle.ResetContent();
	m_ctlComboVisibleGrid.SetCurSel( 0 );
	m_ctlComboPlacementGrid.SetCurSel( 0 );
	m_ctlComboRoutingGrid.SetCurSel( 0 );
	m_ctlComboSnapAngle.SetCurSel( 0 );
	for( int i=0; i<visible->GetSize(); i++ )
	{
		CString str;
		double val = (*m_v)[i];
		BOOL is_mm = ( val < 0 );
		val = fabs( val );
		if( is_mm )
			str.Format(_T("%9.3f"), val/1000000.0 );
		else
			str.Format(_T("%9.3f"), val/NM_PER_MIL );
		str.Trim();
		if( str[str.GetLength()-1] == _T('0'))
			str = str.Left( str.GetLength()-1 );
		if( str[str.GetLength()-1] == _T('0'))
			str = str.Left( str.GetLength()-1 );
		if( str[str.GetLength()-1] == _T('0'))
			str = str.Left( str.GetLength()-1 );
		if( str[str.GetLength()-1] == _T('.'))
			str = str.Left( str.GetLength()-1 );
		if( is_mm )
			m_ctlComboVisibleGrid.AddString( str + _T(" mm"));
		else
			m_ctlComboVisibleGrid.AddString( str );
		if( val == vg )
			m_ctlComboVisibleGrid.SetCurSel( i );
	}
	for( int i=0; i<placement->GetSize(); i++ )
	{
		CString str;
		double val = (*m_p)[i];
		BOOL is_mm = ( val < 0 );
		val = fabs( val );
		if( is_mm )
			str.Format(_T("%9.3f"), val/1000000.0 );
		else
			str.Format(_T("%9.3f"), val/NM_PER_MIL );
		str.Trim();
		if( str[str.GetLength()-1] == _T('0'))
			str = str.Left( str.GetLength()-1 );
		if( str[str.GetLength()-1] == _T('0'))
			str = str.Left( str.GetLength()-1 );
		if( str[str.GetLength()-1] == _T('0'))
			str = str.Left( str.GetLength()-1 );
		if( str[str.GetLength()-1] == _T('.'))
			str = str.Left( str.GetLength()-1 );
		if( is_mm )
			m_ctlComboPlacementGrid.AddString( str + _T(" mm"));
		else
			m_ctlComboPlacementGrid.AddString( str );
		if( val == pg )
			m_ctlComboPlacementGrid.SetCurSel( i );
	}
	if( routing != NULL )
	{
		for( int i=0; i<routing->GetSize(); i++ )
		{
			CString str;
			double val = (*m_r)[i];
			BOOL is_mm = ( val < 0 );
			val = fabs( val );
			if( is_mm )
				str.Format(_T("%9.3f"), val/1000000.0 );
			else
				str.Format(_T("%9.3f"), val/NM_PER_MIL );
			str.Trim();
			if( str[str.GetLength()-1] == _T('0'))
				str = str.Left( str.GetLength()-1 );
			if( str[str.GetLength()-1] == _T('0'))
				str = str.Left( str.GetLength()-1 );
			if( str[str.GetLength()-1] == _T('0'))
				str = str.Left( str.GetLength()-1 );
			if( str[str.GetLength()-1] == _T('.'))
				str = str.Left( str.GetLength()-1 );
			if( is_mm )
				m_ctlComboRoutingGrid.AddString( str + _T(" mm"));
			else
				m_ctlComboRoutingGrid.AddString( str );
			if( val == rg )
				m_ctlComboRoutingGrid.SetCurSel( i );
		}
	}
	else
	{
		m_ctlComboRoutingGrid.AddString(_T("---"));
		m_ctlComboRoutingGrid.SetCurSel(0);
	}
	m_ctlComboSnapAngle.AddString(_T("45"));
	m_ctlComboSnapAngle.AddString(_T("90"));
	m_ctlComboSnapAngle.AddString(_T("Off"));
	m_ctlComboSnapAngle.SetCurSel( 0 );
}

/*=============================================================================

=============================================================================*/

void	CMyToolBar::OnSelectVisibleGrid()
{
	CString str;

	int cur_sel = m_ctlComboVisibleGrid.GetCurSel();
	AfxGetMainWnd()->SendMessage( WM_USER_VISIBLE_GRID, WM_BY_INDEX, cur_sel );
	return;
}

/*=============================================================================

=============================================================================*/

void	CMyToolBar::OnSelectPlacementGrid()
{
	CString str;

	int cur_sel = m_ctlComboPlacementGrid.GetCurSel();
	AfxGetMainWnd()->SendMessage( WM_USER_PLACEMENT_GRID, WM_BY_INDEX, cur_sel );
	return;
}

/*=============================================================================

=============================================================================*/

void	CMyToolBar::OnSelectRoutingGrid()
{
	CString str;

	int cur_sel = m_ctlComboRoutingGrid.GetCurSel();
	AfxGetMainWnd()->SendMessage( WM_USER_ROUTING_GRID, WM_BY_INDEX, cur_sel );
	return;
}

/*=============================================================================

=============================================================================*/

void	CMyToolBar::OnSelectSnapAngle()
{
	CString str;

	int cur_sel = m_ctlComboSnapAngle.GetCurSel();
	AfxGetMainWnd()->SendMessage( WM_USER_SNAP_ANGLE, WM_BY_INDEX, cur_sel );
	return;
}

/*=============================================================================

=============================================================================*/

void	CMyToolBar::OnSelectUnits()
{
	CString str;

	int cur_sel = m_ctlComboUnits.GetCurSel();
	AfxGetMainWnd()->SendMessage( WM_USER_UNITS, WM_BY_INDEX, cur_sel );
	return;
}

/*=============================================================================

=============================================================================*/

void	CMyToolBar::SetUnits( int units )
{
	CString str;
	int cur_sel;

	if( units == MIL )
		cur_sel = 0;
	else
		cur_sel = 1;
	m_ctlComboUnits.SetCurSel( cur_sel );	
	AfxGetMainWnd()->SendMessage( WM_USER_UNITS, WM_BY_INDEX, cur_sel );
	return;
}

//-------------------------------------------------------------------------------------------------
// Followng code(s) are from MSDN
// ==============================
// 
// BUG: The gripper bar is drawn incorrectly when an MFC application uses Windows XP Visual Styles
// http://support.microsoft.com/kb/843490/en (English)
//
// BUG: Windows XP Visual X^CgpMFC AvP[VŁAObvo[`悳Ȃ 
// http://support.microsoft.com/kb/843490/ja (Japanese)
//-------------------------------------------------------------------------------------------------

void CMyToolBar::OnNcPaint() 
{
	EraseNonClient();
}
void CMyToolBar::EraseNonClient()
{

	// Get window DC that is clipped to the non-client area.
	CWindowDC dc(this);
	CRect rectClient;
	GetClientRect(rectClient);
	CRect rectWindow;
	GetWindowRect(rectWindow);
	ScreenToClient(rectWindow);
	rectClient.OffsetRect(-rectWindow.left, -rectWindow.top);
	dc.ExcludeClipRect(rectClient);

	// Draw the borders in the non-client area.
	rectWindow.OffsetRect(-rectWindow.left, -rectWindow.top);
	DrawBorders(&dc, rectWindow);

	// Erase the parts that are not drawn.
	dc.IntersectClipRect(rectWindow);
	SendMessage(WM_ERASEBKGND, (WPARAM)dc.m_hDC);

	// Draw the gripper in the non-client area.
	DrawGripper(&dc, rectWindow);
}

/*=============================================================================

=============================================================================*/

void	CMyToolBar::DoPaint(CDC* pDC)
{
	ASSERT_VALID(this);
	ASSERT_VALID(pDC);

	// Paint inside the client area.
	CRect rect;
	GetClientRect(rect);
	DrawBorders(pDC, rect);
	DrawGripper(pDC, rect);
}

/*=============================================================================

=============================================================================*/

void	CMyToolBar::DrawGripper(CDC* pDC, const CRect& rect)
{
	pDC->FillSolidRect( &rect, ::GetSysColor(COLOR_BTNFACE)); // Fill in the background.
	CToolBar::DrawGripper(pDC,rect);
}


