#pragma once
#include "FreePcbView.h"

// CMyToolBar

/*=============================================================================
						CMyToolBar NX̐錾
=============================================================================*/

class CMyToolBar : public CToolBar
{
	DECLARE_DYNAMIC(CMyToolBar)
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
public:
	CMyToolBar();
	virtual ~CMyToolBar();
//--------------------------------------
// f[^o(ϐ)
//--------------------------------------
public:
	CFont				m_font;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int					m_last_vg;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int					m_last_pg;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int					m_last_rg;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CArray<double> *	m_v;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CArray<double> *	m_p;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CArray<double> *	m_r;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
private:
	CStatic				m_ctlStaticUnits;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox			m_ctlComboUnits;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CStatic				m_ctlStaticVisibleGrid;		/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox			m_ctlComboVisibleGrid;		/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CStatic				m_ctlStaticPlacementGrid;	/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox			m_ctlComboPlacementGrid;	/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CStatic				m_ctlStaticRoutingGrid;		/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox			m_ctlComboRoutingGrid;		/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CStatic				m_ctlStaticSnapAngle;		/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox			m_ctlComboSnapAngle;		/**< ToDo:Describe short comment, about this member variable for Doxygen			*/

	CImageList			m_gdiToolBarImage256;
//--------------------------------------
// 
//--------------------------------------
public:
	void SetLists( CArray<double> * visible, 
		CArray<double> * placement, 
		CArray<double> * routing,
		double vg, double pg, double rg, int ag, int units );

	void OnSelectVisibleGrid();
	void OnSelectPlacementGrid();
	void OnSelectRoutingGrid();
	void OnSelectSnapAngle();
	void OnSelectUnits();
	void SetUnits( int units );
public:
	void DrawGripper(CDC* pDC, const CRect& rect);
	void EraseNonClient();
	virtual void DoPaint(CDC* pDC);
//--------------------------------------
// Generated message map function(s)
//--------------------------------------
protected:
	//{{AFX_MSG(CMyToolBar)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnNcPaint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
/*-----------------------------------------------------------------------------
								end of MyToolBar.h
-----------------------------------------------------------------------------*/
