#pragma once
#include "afxwin.h"
#include "Netlist.h"


// CDlgAddArea dialog

/*=============================================================================
					CDlgAddArea _CAO NX̐錾
=============================================================================*/

class CDlgAddArea : public CDialog
{
	DECLARE_DYNAMIC(CDlgAddArea)
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
public:
	CDlgAddArea(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDlgAddArea();
	void Initialize( CNetList * nl, int nlayers, cnet * net, int layer, int hatch );

	CString		GetNetName() const	{ return(m_strNetName); }
//--------------------------------------
// _CAO f[^(萔)
//--------------------------------------
protected:
	//{{AFX_DATA(CDlgAddArea)
	enum { IDD = IDD_ADD_AREA };
	//}}AFX_DATA
//--------------------------------------
// Override(s) - yz֐z
//--------------------------------------
	//{{AFX_VIRTUAL(CDlgAddArea)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
//--------------------------------------
// _CAO f[^(ϐ)
//--------------------------------------
public:
	int			m_layer;						/**< set to selected layer on return					*/
	BOOL		bNewArea;						/**< ToDo:Describe short comment, about this member variable for Doxygen					*/
	cnet		*m_net;							/**< set to selected net, or NULL if net doesn't exist	*/
	int			m_hatch;						/**< ToDo:Describe short comment, about this member variable for Doxygen					*/
protected:
	CString		m_strNetName;					/**< set to net name on return							*/
	CNetList	*m_nlist;						/**< ToDo:Describe short comment, about this member variable for Doxygen					*/
	int			m_num_layers;					/**< ToDo:Describe short comment, about this member variable for Doxygen					*/
private:
	CComboBox	m_wndNetComboBox;				/**< ToDo:Describe short comment, about this member variable for Doxygen					*/
	CListBox	m_wndLayerListBox;				/**< ToDo:Describe short comment, about this member variable for Doxygen					*/
	CButton		m_wndNoneBtn;					/**< ToDo:Describe short comment, about this member variable for Doxygen					*/
	CButton		m_wndFillBtn;					/**< ToDo:Describe short comment, about this member variable for Doxygen					*/
	CButton		m_wndEdgeBtn;					/**< ToDo:Describe short comment, about this member variable for Doxygen					*/
//--------------------------------------
// Generated message map function(s)
//--------------------------------------
	//{{AFX_MSG(CDlgAddArea)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
/*-----------------------------------------------------------------------------
							end of DlgAddArea.h
-----------------------------------------------------------------------------*/
