#pragma once
#include "afxwin.h"
#include "afxcmn.h"
#include "FreePcbDoc.h"

// CDlgAddPart dialog

/*=============================================================================

=============================================================================*/

enum {
	MSK_FOOTPRINT = 1,
	MSK_PACKAGE = 2,
	MSK_VALUE = 4
};

/*=============================================================================
					CDlgAddPart _CAO NX̐錾
=============================================================================*/

class CDlgAddPart : public CDialog
{
	DECLARE_DYNAMIC(CDlgAddPart)
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
public:
	CDlgAddPart(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDlgAddPart();

//--------------------------------------
// _CAO f[^(萔)
//--------------------------------------
protected:
	//{{AFX_DATA(CDlgAddPart)
	enum { IDD = IDD_ADD_PART };
	//}}AFX_DATA
//--------------------------------------
// Override(s) - yz֐z
//--------------------------------------
	//{{AFX_VIRTUAL(CDlgAddPart)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

//--------------------------------------
// _CAO f[^(ϐ)
//--------------------------------------
public:
	int				m_units;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_x;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_y;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_angle;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_multiple_mask;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
private:
	CString			m_footprint_name;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_ilib;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_ihead;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_ifoot;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	BOOL			m_in_cache;							/**< true if new footprint selected from cache	*/
	CShape			m_shape;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	BOOL			m_drag_flag;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	BOOL			m_offboard_flag;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	partlist_info	*m_pl;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_ip;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	BOOL			m_standalone;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	BOOL			m_new_part;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	BOOL			m_multiple;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox		m_wndComboBox_shape;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CMapStringToPtr		*m_footprint_cache_map;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CFootLibFolderMap	*m_footlibfoldermap;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CFootLibFolder		*m_folder;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CTreeCtrl		part_tree;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
private:
	CEdit			m_wndEditCtrl_ref_des;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit			m_wndEditCtrl_package;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit			m_wndEditCtrl_footprint;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit			m_wndEditCtrl_value;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton			m_wndCheckBtn_value_visible;		/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton			m_wndRadioBtn_drag;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton			m_wndRadioBtn_offboard;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton			m_wndRadioBtn_set;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit			m_wndEditCtrl_x;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit			m_wndEditCtrl_y;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CListBox		m_list_side;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CStatic			m_preview;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox		m_wndComboBox_units;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit			m_wndEditCtrl_author;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit			m_wndEditCtrl_source;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit			m_wndEditCtrl_desc;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton			m_wndPushBtn_browse;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit			m_wndEditCtrl_lib;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox		m_wndComboBox_angle;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
public:
	void Initialize(partlist_info * pl
				   ,int i
				   ,BOOL standalone
				   ,BOOL new_part
				   ,BOOL multiple
				   ,int multiple_mask
				   ,CMapStringToPtr * shape_cache_map
				   ,CFootLibFolderMap * footlibfoldermap
				   ,int units);
//				   ,CDlgLog * log);
	void InitPartLibTree();
	BOOL GetDragFlag();
	void SetFields();
	void GetFields();

//--------------------------------------
// Generated message map function(s)
//--------------------------------------
	//{{AFX_MSG(CDlgAddPart)
private:
	virtual BOOL OnInitDialog();
	afx_msg void OnBnClickedRadioDrag();
	afx_msg void OnBnClickedRadioSet();
	afx_msg void OnTvnSelchangedPartLibTree(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedRadioOffBoard();
	afx_msg void OnBnClickedButtonBrowse();
	afx_msg void OnCbnSelchangeComboAddPartUnits();
	afx_msg void OnBnClickedCancel();
	afx_msg void OnBnClickedOk();
	//}}AFX_MSG
public:
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
/*-----------------------------------------------------------------------------
							end of DlgAddPart.h
-----------------------------------------------------------------------------*/
