// DlgDRC.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgDRC.h"

#define nm_per_mil 25400.0 

// DlgDRC dialog

IMPLEMENT_DYNAMIC(DlgDRC, CDialog)

/*=============================================================================
						DlgDRC NX̍\z
=============================================================================*/

DlgDRC::DlgDRC(CWnd* pParent /*=NULL*/)
	: CDialog(DlgDRC::IDD, pParent)
{
	//{{AFX_DATA_INIT(DlgDRC)
	//}}AFX_DATA_INIT
}

/*=============================================================================
						DlgDRC NX̏
=============================================================================*/

DlgDRC::~DlgDRC()
{
}

/*=============================================================================
			DlgDRC _CAOf[^̌ƗL`FbN
=============================================================================*/

void	DlgDRC::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DlgDRC)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_COMBO1, m_wndComboBox_units);
	DDX_Control(pDX, IDC_EDIT1, m_wndEditCtrl_pad_pad);
	DDX_Control(pDX, IDC_EDIT7, m_wndEditCtrl_pad_trace);
	DDX_Control(pDX, IDC_EDIT6, m_wndEditCtrl_trace_trace);
	DDX_Control(pDX, IDC_EDIT5, m_wndEditCtrl_hole_copper);
	DDX_Control(pDX, IDC_EDIT4, m_wndEditCtrl_annular_ring_pins);
	DDX_Control(pDX, IDC_EDIT2, m_wndEditCtrl_board_edge_copper);
	DDX_Control(pDX, IDC_EDIT8, m_wndEditCtrl_hole_hole);
	DDX_Control(pDX, IDC_EDIT9, m_wndEditCtrl_annular_ring_vias);
	DDX_Control(pDX, IDC_EDIT10, m_wndEditCtrl_copper_copper);
	DDX_Control(pDX, IDC_EDIT14, m_wndEditCtrl_trace_width);
	DDX_Control(pDX, IDC_EDIT11, m_wndEditCtrl_board_edge_hole);
	DDX_Control(pDX, IDC_CHECK_SHOW_UNROUTED, m_wndCheckBtn_show_unrouted);
	if(!pDX->m_bSaveAndValidate)			/* ϐRg[	*/
	{
		// incoming
		m_wndComboBox_units.InsertString( 0,_T("MIL"));
		m_wndComboBox_units.InsertString( 1,_T("MM"));
		if( m_units == MIL )
			m_wndComboBox_units.SetCurSel( 0 );
		else
			m_wndComboBox_units.SetCurSel( 1 );
		SetFields();
	}
}

/*=============================================================================
					DlgDRC NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(DlgDRC, CDialog)
	//{{AFX_MSG_MAP(DlgDRC)
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(IDC_COMBO1, OnCbnChangeUnits)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedCheck)
END_MESSAGE_MAP()


// Initialize
/*=============================================================================

=============================================================================*/

void	DlgDRC::Initialize(int units								/**< ToDo:Add Comment for Doxygen			*/
						  ,DesignRules * dr							/**< ToDo:Add Comment for Doxygen			*/
						  ,CPartList * pl							/**< ToDo:Add Comment for Doxygen			*/
						  ,CNetList * nl							/**< ToDo:Add Comment for Doxygen			*/
						  ,DRErrorList * drelist					/**< ToDo:Add Comment for Doxygen			*/
						  ,int copper_layers						/**< ToDo:Add Comment for Doxygen			*/
						  ,CArray<CPolyLine> * board_outline		/**< ToDo:Add Comment for Doxygen			*/
						  ,int CAM_annular_ring_pins				/**< ToDo:Add Comment for Doxygen			*/
						  ,int CAM_annular_ring_vias				/**< ToDo:Add Comment for Doxygen			*/ )
{
	m_units = units; 
	m_dr = dr;
	m_dr_local = *dr;
	m_pl = pl;
	m_nl = nl;
	m_copper_layers = copper_layers;
	m_board_outline = board_outline;
	m_CAM_annular_ring_pins = CAM_annular_ring_pins;
	m_CAM_annular_ring_vias = CAM_annular_ring_vias;
	m_drelist = drelist;
}

/*=============================================================================

=============================================================================*/

void	DlgDRC::GetFields()
{
	CString str;
	m_dr_local.bCheckUnrouted = m_wndCheckBtn_show_unrouted.GetCheck();
	if( m_units == MIL )
	{
		m_wndEditCtrl_trace_width.GetWindowText( str );
		m_dr_local.trace_width = _tstof( str ) * nm_per_mil;
		m_wndEditCtrl_pad_pad.GetWindowText( str );
		m_dr_local.pad_pad = _tstof( str ) * nm_per_mil;
		m_wndEditCtrl_pad_trace.GetWindowText( str );
		m_dr_local.pad_trace = _tstof( str ) * nm_per_mil;
		m_wndEditCtrl_trace_trace.GetWindowText( str );
		m_dr_local.trace_trace = _tstof( str ) * nm_per_mil;
		m_wndEditCtrl_hole_copper.GetWindowText( str );
		m_dr_local.hole_copper = _tstof( str ) * nm_per_mil;
		m_wndEditCtrl_annular_ring_pins.GetWindowText( str );
		m_dr_local.annular_ring_pins = _tstof( str ) * nm_per_mil;
		m_wndEditCtrl_annular_ring_vias.GetWindowText( str );
		m_dr_local.annular_ring_vias = _tstof( str ) * nm_per_mil;
		m_wndEditCtrl_board_edge_copper.GetWindowText( str );
		m_dr_local.board_edge_copper = _tstof( str ) * nm_per_mil;
		m_wndEditCtrl_board_edge_hole.GetWindowText( str );
		m_dr_local.board_edge_hole = _tstof( str ) * nm_per_mil;
		m_wndEditCtrl_hole_hole.GetWindowText( str );
		m_dr_local.hole_hole = _tstof( str ) * nm_per_mil;
		m_wndEditCtrl_copper_copper.GetWindowText( str );
		m_dr_local.copper_copper = _tstof( str ) * nm_per_mil;
	}
	else
	{
		m_wndEditCtrl_trace_width.GetWindowText( str );
		m_dr_local.trace_width = _tstof( str ) * 1000000.0;
		m_wndEditCtrl_pad_pad.GetWindowText( str );
		m_dr_local.pad_pad = _tstof( str ) * 1000000.0;
		m_wndEditCtrl_pad_trace.GetWindowText( str );
		m_dr_local.pad_trace = _tstof( str ) * 1000000.0;
		m_wndEditCtrl_trace_trace.GetWindowText( str );
		m_dr_local.trace_trace = _tstof( str ) * 1000000.0;
		m_wndEditCtrl_hole_copper.GetWindowText( str );
		m_dr_local.hole_copper = _tstof( str ) * 1000000.0;
		m_wndEditCtrl_annular_ring_pins.GetWindowText( str );
		m_dr_local.annular_ring_pins = _tstof( str ) * 1000000.0;
		m_wndEditCtrl_annular_ring_vias.GetWindowText( str );
		m_dr_local.annular_ring_vias = _tstof( str ) * 1000000.0;
		m_wndEditCtrl_board_edge_copper.GetWindowText( str );
		m_dr_local.board_edge_copper = _tstof( str ) * 1000000.0;
		m_wndEditCtrl_board_edge_hole.GetWindowText( str );
		m_dr_local.board_edge_hole = _tstof( str ) * 1000000.0;
		m_wndEditCtrl_hole_hole.GetWindowText( str );
		m_dr_local.hole_hole = _tstof( str ) * 1000000.0;
		m_wndEditCtrl_copper_copper.GetWindowText( str );
		m_dr_local.copper_copper = _tstof( str ) * 1000000.0;
	}
}

/*=============================================================================

=============================================================================*/

void	DlgDRC::SetFields()
{
	CString str;
	m_wndCheckBtn_show_unrouted.SetCheck( m_dr_local.bCheckUnrouted );
	if( m_units == MIL )
	{
		MakeCStringFromDouble( &str, m_dr_local.trace_width/nm_per_mil );
		m_wndEditCtrl_trace_width.SetWindowText( str );
		MakeCStringFromDouble( &str, m_dr_local.pad_pad/nm_per_mil );
		m_wndEditCtrl_pad_pad.SetWindowText( str );
		MakeCStringFromDouble( &str, m_dr_local.pad_trace/nm_per_mil );
		m_wndEditCtrl_pad_trace.SetWindowText( str );
		MakeCStringFromDouble( &str, m_dr_local.trace_trace/nm_per_mil );
		m_wndEditCtrl_trace_trace.SetWindowText( str );
		MakeCStringFromDouble( &str, m_dr_local.hole_copper/nm_per_mil );
		m_wndEditCtrl_hole_copper.SetWindowText( str );
		MakeCStringFromDouble( &str, m_dr_local.annular_ring_pins/nm_per_mil );
		m_wndEditCtrl_annular_ring_pins.SetWindowText( str );
		MakeCStringFromDouble( &str, m_dr_local.annular_ring_vias/nm_per_mil );
		m_wndEditCtrl_annular_ring_vias.SetWindowText( str );
		MakeCStringFromDouble( &str, m_dr_local.board_edge_copper/nm_per_mil );
		m_wndEditCtrl_board_edge_copper.SetWindowText( str );
		MakeCStringFromDouble( &str, m_dr_local.board_edge_hole/nm_per_mil );
		m_wndEditCtrl_board_edge_hole.SetWindowText( str );
		MakeCStringFromDouble( &str, m_dr_local.hole_hole/nm_per_mil );
		m_wndEditCtrl_hole_hole.SetWindowText( str );
		MakeCStringFromDouble( &str, m_dr_local.copper_copper/nm_per_mil );
		m_wndEditCtrl_copper_copper.SetWindowText( str );
	}
	else
	{
		MakeCStringFromDouble( &str, m_dr_local.trace_width/1000000.0 );
		m_wndEditCtrl_trace_width.SetWindowText( str );
		MakeCStringFromDouble( &str, m_dr_local.pad_pad/1000000.0 );
		m_wndEditCtrl_pad_pad.SetWindowText( str );
		MakeCStringFromDouble( &str, m_dr_local.pad_trace/1000000.0 );
		m_wndEditCtrl_pad_trace.SetWindowText( str );
		MakeCStringFromDouble( &str, m_dr_local.trace_trace/1000000.0 );
		m_wndEditCtrl_trace_trace.SetWindowText( str );
		MakeCStringFromDouble( &str, m_dr_local.hole_copper/1000000.0 );
		m_wndEditCtrl_hole_copper.SetWindowText( str );
		MakeCStringFromDouble( &str, m_dr_local.annular_ring_pins/1000000.0 );
		m_wndEditCtrl_annular_ring_pins.SetWindowText( str );
		MakeCStringFromDouble( &str, m_dr_local.annular_ring_vias/1000000.0 );
		m_wndEditCtrl_annular_ring_vias.SetWindowText( str );
		MakeCStringFromDouble( &str, m_dr_local.board_edge_copper/1000000.0 );
		m_wndEditCtrl_board_edge_copper.SetWindowText( str );
		MakeCStringFromDouble( &str, m_dr_local.board_edge_hole/1000000.0 );
		m_wndEditCtrl_board_edge_hole.SetWindowText( str );
		MakeCStringFromDouble( &str, m_dr_local.hole_hole/1000000.0 );
		m_wndEditCtrl_hole_hole.SetWindowText( str );
		MakeCStringFromDouble( &str, m_dr_local.copper_copper/1000000.0 );
		m_wndEditCtrl_copper_copper.SetWindowText( str );
	}
}

// DlgDRC message handlers

void DlgDRC::OnCbnChangeUnits()
{
	CString str;
	m_wndComboBox_units.GetWindowText( str );
	GetFields();
	if( str ==_T("MIL"))
		m_units = MIL;
	else
		m_units = MM;
	SetFields();
}

// the actual checker
//
void DlgDRC::CheckDesign()
{
	CString str;

	GetFields();

	// warnings
	CString mess;
	if( m_dr_local.annular_ring_pins > m_CAM_annular_ring_pins )  
	{
		mess = "Warning: Your design rule for minimum annular ring width for pins\n";
		mess += "exceeds the default annular ring width in the CAM dialog.\n";
		mess += "This will probably create DRC errors.\n\n";
		mess += "Do you want to set the CAM parameter to match the design rule?";
		int ret = AfxMessageBox( mess, MB_YESNOCANCEL );
		if( ret == IDCANCEL )
			return;
		else if( ret == IDYES )
		{
			m_CAM_annular_ring_pins = m_dr_local.annular_ring_pins;
			m_pl->SetPinAnnularRing( m_CAM_annular_ring_pins );
		}
	}
	if( m_dr_local.annular_ring_vias > m_CAM_annular_ring_vias )
	{
		mess = "Warning: Your design rule for minimum annular ring width for vias\n";
		mess += "exceeds the default annular ring width in the CAM dialog.\n";
		mess += "This will probably create DRC errors.\n\n";
		mess += "Do you want to set the CAM parameter to match the design rule?";
		int ret = AfxMessageBox( mess, MB_YESNOCANCEL );
		if( ret == IDCANCEL )
			return;
		else if( ret == IDYES )
		{
			m_CAM_annular_ring_vias = m_dr_local.annular_ring_vias;
			m_nl->SetViaAnnularRing( m_CAM_annular_ring_vias );
		}
	}
	CDlgLog		*pLogDialog;

	pLogDialog=((CMainFrame *)AfxGetMainWnd())->GetLogDialog();
	ASSERT(pLogDialog);

	if(pLogDialog)
	{
		pLogDialog->ShowWindow( SW_SHOW );
		pLogDialog->UpdateWindow();
		pLogDialog->BringWindowToTop();
		pLogDialog->Clear();
		pLogDialog->UpdateWindow();
		m_drelist->Clear();
		m_pl->DRC(pLogDialog
				 ,m_copper_layers
				 ,m_units
				 ,m_wndCheckBtn_show_unrouted
				 .GetCheck()
				 ,m_board_outline
				 ,&m_dr_local
				 ,m_drelist); 
	}
}

void DlgDRC::OnBnClickedCancel()
{
	OnCancel();
}

void DlgDRC::OnBnClickedOk()
{
	GetFields();
	*m_dr = m_dr_local;
	OnOK();
}

void DlgDRC::OnBnClickedCheck()
{
	CheckDesign();
//	OnOK();
}
