// DlgDupFootprintName.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgDupFootprintName.h"


// CDlgDupFootprintName dialog

IMPLEMENT_DYNAMIC(CDlgDupFootprintName, CDialog)

/*=============================================================================
					CDlgDupFootprintName NX̍\z
=============================================================================*/

CDlgDupFootprintName::CDlgDupFootprintName(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgDupFootprintName::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgDupFootprintName)
	//}}AFX_DATA_INIT
}

/*=============================================================================
					CDlgDupFootprintName NX̏
=============================================================================*/

CDlgDupFootprintName::~CDlgDupFootprintName()
{
}

/*=============================================================================
		CDlgDupFootprintName _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgDupFootprintName::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgDupFootprintName)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_EDIT_DUP_MESSAGE, m_wndEditCtrl_message);
	DDX_Control(pDX, IDC_RADIO_REPLACE_ALL, m_wndRadioBtn_replace_all);
	DDX_Control(pDX, IDC_RADIO_REPLACE_THIS, m_wndRadioBtn_replace_this);
	DDX_Control(pDX, IDC_EDIT_NEW_FP_NAME, m_wndEditCtrl_new_name);
	if(!pDX->m_bSaveAndValidate)			/* ϐRg[	*/
	{
		// incoming
		m_wndEditCtrl_message.SetWindowText( *m_str );
		m_wndRadioBtn_replace_all.SetCheck( 1 );
		m_wndEditCtrl_new_name.EnableWindow( 0 );
	}
	else
	{
		// outgoing
		m_replace_all_flag = m_wndRadioBtn_replace_all.GetCheck();
		m_wndEditCtrl_new_name.GetWindowText( m_new_name_str );
		if( m_replace_all_flag == FALSE )
		{
			if( m_new_name_str.IsEmpty() )
			{
				// blank name
				AfxMessageBox(_T("You must enter a new footprint name"));
				pDX->Fail();
			}
			void * ptr;
			if( m_footprint_cache_map->Lookup( m_new_name_str, ptr ) )
			{
				// blank name
				AfxMessageBox(_T("New footprint name is already in use"));
				pDX->Fail();
			}
		}
	}
}

/*=============================================================================
				CDlgDupFootprintName NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgDupFootprintName, CDialog)
	//{{AFX_MSG_MAP(CDlgDupFootprintName)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_RADIO_REPLACE_ALL, OnBnClickedRadioReplaceAll)
	ON_BN_CLICKED(IDC_RADIO_REPLACE_THIS, OnBnClickedRadioReplaceThis)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
END_MESSAGE_MAP()

// initialize the dialog
//
void CDlgDupFootprintName::Initialize(CString * message						/**< ToDo:Add Comment for Doxygen			*/
									 ,CMapStringToPtr * shape_cache_map		/**< ToDo:Add Comment for Doxygen			*/ )
{
	m_str = message;
	m_footprint_cache_map = shape_cache_map;
}


// CDlgDupFootprintName message handlers

void CDlgDupFootprintName::OnBnClickedRadioReplaceAll()
{
	m_wndEditCtrl_new_name.EnableWindow( 0 );
}

void CDlgDupFootprintName::OnBnClickedRadioReplaceThis()
{
	m_wndEditCtrl_new_name.EnableWindow( 1 );
}

void CDlgDupFootprintName::OnBnClickedOk()
{
	m_replace_all_flag = m_wndRadioBtn_replace_all.GetCheck();
	OnOK();
}
