#pragma once
#include "afxwin.h"


// CDlgExportDsn dialog

/*=============================================================================
				  CDlgExportDsn _CAO NX̐錾
=============================================================================*/

class CDlgExportDsn : public CDialog
{
	DECLARE_DYNAMIC(CDlgExportDsn)
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
public:
	CDlgExportDsn(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDlgExportDsn();
	void Initialize( CString * dsn_filepath,
					 int num_board_outline_polys,
					 int bounds_poly, int signals_poly,
					 int flags );


//--------------------------------------
// _CAO f[^(萔)
//--------------------------------------
protected:
	//{{AFX_DATA(CDlgExportDsn)
	enum { IDD = IDD_EXPORT_DSN };
	//}}AFX_DATA
public:
	// flags for options
	enum {
		DSN_VERBOSE = 0x1,
		DSN_INFO_ONLY = 0x2,
		DSN_FROM_TO_MASK = 0xC,
		DSN_FROM_TO_NONE = 0,
		DSN_FROM_TO_ALL = 0x4,
		DSN_FROM_TO_LOCKED = 0x8,
		DSN_FROM_TO_NET_LOCKED = 0xC
	};

//--------------------------------------
// Override(s) - yz֐z
//--------------------------------------
	//{{AFX_VIRTUAL(CDlgExportDsn)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

//--------------------------------------
// _CAO f[^(ϐ)
//--------------------------------------
public:
	int m_num_polys;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int m_bounds_poly;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int m_signals_poly;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int m_flags;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
private:
	CComboBox m_wndComboBox_bounds;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox m_wndComboBox_signals;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CString m_dsn_filepath;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton m_wndCheckBtn_verbose;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton m_wndCheckBtn_info;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton m_wndCheckBtn_from_to;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton m_wndRadioBtn_all;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton m_wndRadioBtn_locked;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton m_wndRadioBtn_net_locked;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
//--------------------------------------
// Generated message map function(s)
//--------------------------------------
protected:
	//{{AFX_MSG(CDlgExportDsn)
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCheckFromTo();
	afx_msg void OnBnClickedRadioAll();
	afx_msg void OnBnClickedRadioLocked();
	afx_msg void OnBnClickedRadioNetLocked();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
