// DlgFpRefText.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgFpRefText.h"
#include ".\dlgfpreftext.h"


// CDlgFpRefText dialog

IMPLEMENT_DYNAMIC(CDlgFpRefText, CDialog)

/*=============================================================================
						CDlgFpRefText NX̍\z
=============================================================================*/

CDlgFpRefText::CDlgFpRefText(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgFpRefText::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgFpRefText)
	//}}AFX_DATA_INIT
}

/*=============================================================================
						CDlgFpRefText NX̏
=============================================================================*/

CDlgFpRefText::~CDlgFpRefText()
{
}

/*=============================================================================

=============================================================================*/

void	CDlgFpRefText::Initialize(int height			/**< ToDo:Add Comment for Doxygen			*/
								 ,int width				/**< ToDo:Add Comment for Doxygen			*/
								 ,int units				/**< ToDo:Add Comment for Doxygen			*/ )
{
	m_height = height;
	m_width = width;
	m_units = units;
}

/*=============================================================================
			CDlgFpRefText _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgFpRefText::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgFpRefText)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_COMBO_FP_REF_TEXT_UNITS, m_wndComboBox_units);
	DDX_Control(pDX, IDC_EDIT_FP_REF_CHAR_HEIGHT, m_wndEditCtrl_height);
	DDX_Control(pDX, IDC_RADIO_FP_REF_SET, m_wndRadioBtn_set);
	DDX_Control(pDX, IDC_EDIT_FP_REF_WIDTH, m_wndEditCtrl_width);
	DDX_Control(pDX, IDC_RADIO_FP_REF_DEF, m_wndRadioBtn_def);
	DDX_Control(pDX, IDC_EDIT_FP_REF_DEF_WIDTH, m_wndEditCtrl_def_width);
	if(!pDX->m_bSaveAndValidate)			/* ϐRg[	*/
	{
		// incoming
		m_wndComboBox_units.InsertString( 0,_T("MIL"));
		m_wndComboBox_units.InsertString( 1,_T("MM"));
		if( m_units == MIL )
			m_wndComboBox_units.SetCurSel( 0 );
		else
			m_wndComboBox_units.SetCurSel( 1 );
		SetFields();
		m_wndRadioBtn_set.SetCheck( 1 );
		m_wndEditCtrl_def_width.EnableWindow( FALSE );
		m_wndEditCtrl_width.EnableWindow( TRUE );
	}
	else
	{
		// outgoing
		GetFields();
		if( m_wndRadioBtn_def.GetCheck() )
			m_width = m_def_width;
	}
}

/*=============================================================================
					CDlgFpRefText NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgFpRefText, CDialog)
	//{{AFX_MSG_MAP(CDlgFpRefText)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_RADIO_FP_REF_SET, OnBnClickedRadioSet)
	ON_BN_CLICKED(IDC_RADIO_FP_REF_DEF, OnBnClickedRadioDef)
	ON_CBN_SELCHANGE(IDC_COMBO_FP_REF_TEXT_UNITS, OnCbnSelchangeComboRefTextUnits)
	ON_EN_CHANGE(IDC_EDIT_FP_REF_CHAR_HEIGHT, OnEnChangeEditCharHeight)
END_MESSAGE_MAP()


// CDlgFpRefText message handlers

/*=============================================================================

=============================================================================*/

void	CDlgFpRefText::OnBnClickedRadioSet()
{
	m_wndEditCtrl_width.EnableWindow( TRUE );
}

/*=============================================================================

=============================================================================*/

void	CDlgFpRefText::OnBnClickedRadioDef()
{
	m_wndEditCtrl_width.EnableWindow( FALSE );
}

/*=============================================================================

=============================================================================*/

void	CDlgFpRefText::OnCbnSelchangeComboRefTextUnits()
{
	GetFields();
	if( m_wndComboBox_units.GetCurSel() == 0 )
		m_units = MIL;
	else
		m_units = MM;
	SetFields();
}

/*=============================================================================

=============================================================================*/

void	CDlgFpRefText::OnEnChangeEditCharHeight()
{
	CString str;
	m_wndEditCtrl_height.GetWindowText( str );
	if( m_units == MIL )
		m_height = _tstof( str ) * NM_PER_MIL;
	else
		m_height = _tstof( str ) * 1000000.0;
	m_def_width = m_height/10;
	if( m_def_width < 1*NM_PER_MIL )
		m_def_width = 1*NM_PER_MIL;
	if( m_units == MIL )
	{
		MakeCStringFromDouble( &str, m_def_width/NM_PER_MIL );
		m_wndEditCtrl_def_width.SetWindowText( str );
	}
	else
	{
		MakeCStringFromDouble( &str, m_def_width/1000000.0 );
		m_wndEditCtrl_def_width.SetWindowText( str );
	}
}

/*=============================================================================

=============================================================================*/

void	CDlgFpRefText::GetFields()
{
	CString str;
	if( m_units == MIL )
	{
		m_wndEditCtrl_height.GetWindowText( str );
		m_height = _tstof( str ) * NM_PER_MIL;
		m_wndEditCtrl_width.GetWindowText( str );
		m_width = _tstof( str ) * NM_PER_MIL;
	}
	else
	{
		m_wndEditCtrl_height.GetWindowText( str );
		m_height = _tstof( str ) * 1000000.0;
		m_wndEditCtrl_width.GetWindowText( str );
		m_width = _tstof( str ) * 1000000.0;
	}
	m_def_width = m_height/10;
}

/*=============================================================================

=============================================================================*/

void	CDlgFpRefText::SetFields()
{
	CString str;
	m_def_width = m_height/10;
	if( m_def_width < 1*NM_PER_MIL )
		m_def_width = 1*NM_PER_MIL;
	if( m_units == MIL )
	{
		MakeCStringFromDouble( &str, m_height/NM_PER_MIL );
		m_wndEditCtrl_height.SetWindowText( str );
		MakeCStringFromDouble( &str, m_width/NM_PER_MIL );
		m_wndEditCtrl_width.SetWindowText( str );
		MakeCStringFromDouble( &str, m_def_width/NM_PER_MIL );
		m_wndEditCtrl_def_width.SetWindowText( str );
	}
	else
	{
		MakeCStringFromDouble( &str, m_height/1000000.0 );
		m_wndEditCtrl_height.SetWindowText( str );
		MakeCStringFromDouble( &str, m_width/1000000.0 );
		m_wndEditCtrl_width.SetWindowText( str );
		MakeCStringFromDouble( &str, m_def_width/1000000.0 );
		m_wndEditCtrl_def_width.SetWindowText( str );
	}
}

