#pragma once
#include "afxwin.h"
#include "afxcmn.h"


// CDlgGroupPaste dialog

/*=============================================================================
				  CDlgGroupPaste _CAO NX̐錾
=============================================================================*/

class CDlgGroupPaste : public CDialog
{
	DECLARE_DYNAMIC(CDlgGroupPaste)
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
public:
	CDlgGroupPaste(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDlgGroupPaste();
	void Initialize( CNetList * grp_nlist );
	void SetFields();
//--------------------------------------
// _CAO f[^(萔)
//--------------------------------------
public:
// columns for list
enum
{
	 COL_VIS = 0						/**< ToDo:Describe short comment, about this enum constant value for Doxygen		*/
	,COL_NAME							/**< ToDo:Describe short comment, about this enum constant value for Doxygen		*/
	,COL_PINS							/**< ToDo:Describe short comment, about this enum constant value for Doxygen		*/
	,COL_WIDTH							/**< ToDo:Describe short comment, about this enum constant value for Doxygen		*/
	,COL_VIA_W							/**< ToDo:Describe short comment, about this enum constant value for Doxygen		*/
	,COL_HOLE_W							/**< ToDo:Describe short comment, about this enum constant value for Doxygen		*/
};
// sort types
enum
{
	 SORT_UP_NAME = 0					/**< ToDo:Describe short comment, about this enum constant value for Doxygen		*/
	,SORT_DOWN_NAME						/**< ToDo:Describe short comment, about this enum constant value for Doxygen		*/
	,SORT_UP_PINS						/**< ToDo:Describe short comment, about this enum constant value for Doxygen		*/
	,SORT_DOWN_PINS						/**< ToDo:Describe short comment, about this enum constant value for Doxygen		*/
	,SORT_UP_WIDTH						/**< ToDo:Describe short comment, about this enum constant value for Doxygen		*/
	,SORT_DOWN_WIDTH					/**< ToDo:Describe short comment, about this enum constant value for Doxygen		*/
	,SORT_UP_VIA_W						/**< ToDo:Describe short comment, about this enum constant value for Doxygen		*/
	,SORT_DOWN_VIA_W					/**< ToDo:Describe short comment, about this enum constant value for Doxygen		*/
	,SORT_UP_HOLE_W						/**< ToDo:Describe short comment, about this enum constant value for Doxygen		*/
	,SORT_DOWN_HOLE_W					/**< ToDo:Describe short comment, about this enum constant value for Doxygen		*/
};

protected:
	//{{AFX_DATA(CDlgGroupPaste)
	enum { IDD = IDD_GROUP_PASTE };
	//}}AFX_DATA
//--------------------------------------
// _CAO f[^(ϐ)
//--------------------------------------
public:
	int			m_units;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_ref_option;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_ref_offset;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_net_name_option;						/**< 0=group names, 1=rename					*/
	int			m_net_rename_option;					/**< 0=use suffix, 1=next Nnnnnn				*/
	int			m_position_option;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_pin_net_option;						/**< 0=retain all, 1=only for pins with traces	*/
	double		m_dx, m_dy;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_sort_type;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CNetList	*m_grp_nlist;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
private:
	CButton		m_wndRadioBtn_use_group_ref;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_use_next_ref;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_add_ref_offset;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_offset;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_use_group_nets;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_use_selected_nets;		/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CListCtrl	m_wndListCtrl;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_use_suffix;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_make_new_names;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_drag;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_offset;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_x;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_y;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox	m_wndComboBox_units;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_retain_all_nets;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_retain_traces;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
//--------------------------------------
// Override(s) - yz֐z
//--------------------------------------
	//{{AFX_VIRTUAL(CDlgGroupPaste)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
//--------------------------------------
// 
//--------------------------------------
	static int CALLBACK ListCompare( LPARAM lp1, LPARAM lp2, LPARAM type );
//--------------------------------------
// Generated message map function(s)
//--------------------------------------
	//{{AFX_MSG(CDlgGroupPaste)
	afx_msg void OnBnClickedRadioUseGroupRef();
	afx_msg void OnBnClickedRadioUseNextRef();
	afx_msg void OnBnClickedRadioAddRefOffset();
	afx_msg void OnBnClickedRadioUseGroupNets();
	afx_msg void OnBnClickedRadioUseSelectedNets();
	afx_msg void OnBnClickedRadioUseSuffix();
	afx_msg void OnBnClickedRadioMakeNewNames();
	afx_msg void OnBnClickedRadioDrag();
	afx_msg void OnBnClickedRadioOffset();
	afx_msg void OnCbnSelchangeComboGroupUnits();
	afx_msg void OnBnClickedRadioRetainAll();
	afx_msg void OnBnClickedRadioRetainTraces();
	afx_msg void OnLvnColumnClickListSelectGroupNets(NMHDR *pNMHDR, LRESULT *pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
