#pragma once
#include "afxwin.h"
#include "afxcmn.h"


// CDlgImportFootprint dialog

/*=============================================================================
				  CDlgImportFootprint _CAO NX̐錾
=============================================================================*/

class CDlgImportFootprint : public CDialog
{
	DECLARE_DYNAMIC(CDlgImportFootprint)
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
public:
	CDlgImportFootprint(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDlgImportFootprint();
	void InitPartLibTree();
	void InitInstance(CMapStringToPtr * shape_cache_map
					 ,CFootLibFolderMap * foldermap);
//					 ,CDlgLog * log );
//--------------------------------------
// _CAO f[^(萔)
//--------------------------------------
protected:
	//{{AFX_DATA(CDlgImportFootprint)
	enum { IDD = IDD_IMPORT_FOOTPRINT };
	//}}AFX_DATA
//--------------------------------------
// Override(s) - yz֐z
//--------------------------------------
	//{{AFX_VIRTUAL(CDlgImportFootprint)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
//--------------------------------------
// _CAO f[^(ϐ)
//--------------------------------------
public:
	CMapStringToPtr		*m_footprint_cache_map;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CFootLibFolderMap	*m_foldermap;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CFootLibFolder		*m_footlibfolder;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CString				m_footprint_name;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CString				m_footprint_filename;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CString				m_footprint_folder;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CShape				m_shape;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	BOOL				m_in_cache;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int					m_ilib;									/**< indices into libraries						*/
	int					m_ihead;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int					m_ifoot;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
private:
	CButton				m_wndPushBtn_browse;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit				m_wndLibraryFolderPath;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CTreeCtrl			m_wndPartTree;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CStatic				m_preview;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit				m_wndEditCtrl_author;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit				m_wndEditCtrl_source;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit				m_wndEditCtrl_desc;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
//--------------------------------------
// Generated message map function(s)
//--------------------------------------
protected:
	//{{AFX_MSG(CDlgImportFootprint)
	virtual BOOL OnInitDialog();
	afx_msg void OnTvnSelchangedPartLibTree(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedButtonBrowseLibFolder();
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
