#pragma once


#define NUM_DLG_LAYERS (LAY_TOP_COPPER + 16)

// CDlgLayers dialog

/*=============================================================================
						CDlgLayers _CAO NX̐錾
=============================================================================*/

class CDlgLayers : public CDialog
{
	DECLARE_DYNAMIC(CDlgLayers)
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
public:
	CDlgLayers(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDlgLayers();

public:
	void Initialize( int nlayers, int vis[], COLORREF rgb[]);
	void EditColor( int layer );
//--------------------------------------
// _CAO f[^(萔)
//--------------------------------------
protected:
	//{{AFX_DATA(CDlgLayers)
	enum { IDD = IDD_LAYERS };
	//}}AFX_DATA
//--------------------------------------
// Override(s) - yz֐z
//--------------------------------------
	//{{AFX_VIRTUAL(CDlgLayers)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
//--------------------------------------
// _CAO f[^(ϐ)
//--------------------------------------
public:
	int				m_check[NUM_DLG_LAYERS];					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
private:
	int				* m_vis;									/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	COLORREF		m_rgbLayerColor[CFreePcbApp::MAX_LAYERS];	/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	COLORREF		*m_rgb_ptr;									/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_nlayers;									/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CBrush			m_brush;									/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CColorDialog	*m_cdlg;									/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
//--------------------------------------
// Generated message map function(s)
//--------------------------------------
protected:
	//{{AFX_MSG(CDlgLayers)
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	//}}AFX_MSG
	afx_msg void OnLayerBtnClicked(UINT nCtrlID);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
/*-----------------------------------------------------------------------------
							end of DlgLayers.h
-----------------------------------------------------------------------------*/
