// DlgMoveOrigin.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgMoveOrigin.h"
#include ".\dlgmoveorigin.h"


// CDlgMoveOrigin dialog

IMPLEMENT_DYNAMIC(CDlgMoveOrigin, CDialog)

/*=============================================================================
						CDlgMoveOrigin NX̍\z
=============================================================================*/

CDlgMoveOrigin::CDlgMoveOrigin(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgMoveOrigin::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgMoveOrigin)
	//}}AFX_DATA_INIT
}

/*=============================================================================
						CDlgMoveOrigin NX̏
=============================================================================*/

CDlgMoveOrigin::~CDlgMoveOrigin()
{
}

/*=============================================================================
		CDlgMoveOrigin _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgMoveOrigin::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgMoveOrigin)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_RADIO1, m_wndRadioBtn_drag);
	DDX_Control(pDX, IDC_RADIO2, m_wndRadioBtn_set);
	DDX_Control(pDX, IDC_COMBO1, m_wndComboBox_units);
	DDX_Control(pDX, IDC_EDIT1, m_wndEditCtrl_x);
	DDX_Control(pDX, IDC_EDIT2, m_wndEditCtrl_y);
	if(!pDX->m_bSaveAndValidate)			/* ϐRg[	*/
	{
		// incoming
		m_wndComboBox_units.AddString(_T("MIL"));
		m_wndComboBox_units.AddString(_T("MM"));
		m_wndComboBox_units.SetCurSel(0);
		m_wndRadioBtn_drag.SetCheck(1);
		SetFields();
	}
	else
	{
		// outgoing
		GetFields();
	}
}

/*=============================================================================
				CDlgMoveOrigin NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgMoveOrigin, CDialog)
	//{{AFX_MSG_MAP(CDlgMoveOrigin)
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(IDC_COMBO1, OnCbnSelchangeUnits)
	ON_BN_CLICKED(IDC_RADIO1, OnBnClickedDrag)
	ON_BN_CLICKED(IDC_RADIO2, OnBnClickedSet)
END_MESSAGE_MAP()

void CDlgMoveOrigin::Initialize( int units )
{
	m_units = units;
	m_x = m_y = 0;
}

void CDlgMoveOrigin::GetFields()
{
	CString str;
	if( m_wndRadioBtn_drag.GetCheck() )
		m_drag = TRUE;
	else
		m_drag = FALSE;
	m_wndEditCtrl_x.GetWindowText( str );
	m_x = _tstof( str ) * m_mult;
	m_wndEditCtrl_y.GetWindowText( str );
	m_y = _tstof( str ) * m_mult;
}

void CDlgMoveOrigin::SetFields()
{
	CString str;
	if( m_wndComboBox_units.GetCurSel() == 0 )
	{
		m_units = MIL;
		m_mult = NM_PER_MIL;
	}
	else
	{
		m_units = MM;
		m_mult = 1000000.0;
	}
	if( m_wndRadioBtn_drag.GetCheck() )
	{
		m_wndComboBox_units.EnableWindow(0);
		m_wndEditCtrl_x.EnableWindow(0);
		m_wndEditCtrl_y.EnableWindow(0);
		m_x = m_y = 0;
		m_wndEditCtrl_x.SetWindowText(_T(""));
		m_wndEditCtrl_y.SetWindowText(_T(""));
	}
	else
	{
		m_wndComboBox_units.EnableWindow(1);
		m_wndEditCtrl_x.EnableWindow(1);
		m_wndEditCtrl_y.EnableWindow(1);
		MakeCStringFromDouble( &str, m_x/m_mult );
		m_wndEditCtrl_x.SetWindowText( str );
		MakeCStringFromDouble( &str, m_y/m_mult );
		m_wndEditCtrl_y.SetWindowText( str );
	}
}

// CDlgMoveOrigin message handlers

/*=============================================================================

=============================================================================*/

void	CDlgMoveOrigin::OnCbnSelchangeUnits()
{
	GetFields();
	SetFields(); 
}

/*=============================================================================

=============================================================================*/

void	CDlgMoveOrigin::OnBnClickedDrag()
{
	GetFields();
	SetFields(); 
}

/*=============================================================================

=============================================================================*/

void	CDlgMoveOrigin::OnBnClickedSet()
{
	GetFields();
	SetFields(); 
}
