#pragma once
#include "afxcmn.h"
#include "afxwin.h"
#include "Partlist.h"

// CDlgPartlist dialog

/*=============================================================================
				CDlgPartlist _CAO NX̐錾
=============================================================================*/

class CDlgPartlist : public CDialog
{
	DECLARE_DYNAMIC(CDlgPartlist)
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
public:
	CDlgPartlist(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDlgPartlist();

//--------------------------------------
// _CAO f[^(萔)
//--------------------------------------
protected:
	//{{AFX_DATA(CDlgPartlist)
	enum { IDD = IDD_PARTLIST };
	//}}AFX_DATA
//--------------------------------------
// Override(s) - yz֐z
//--------------------------------------
	//{{AFX_VIRTUAL(CDlgPartlist)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

public:
	virtual BOOL OnInitDialog();
	void DrawListCtrl();
	void Initialize(CPartList * plist
				   ,CMapStringToPtr * shape_cache_map
				   ,CFootLibFolderMap * footlibfoldermap
				   ,int units);
	void SaveSelections();
	void RestoreSelections();
//--------------------------------------
// _CAO f[^(ϐ)
//--------------------------------------
protected:
	CPartList			*m_plist;							/**< ToDo:Describe short comment, about this member variable for Doxygen				*/
	CMapStringToPtr		*m_footprint_cache_map;				/**< ToDo:Describe short comment, about this member variable for Doxygen				*/
	CFootLibFolderMap	*m_footlibfoldermap;				/**< ToDo:Describe short comment, about this member variable for Doxygen				*/
	int					m_units;							/**< ToDo:Describe short comment, about this member variable for Doxygen				*/
private:
	int					m_sort_type;						/**< ToDo:Describe short comment, about this member variable for Doxygen				*/
	CListCtrl			m_wndListCtrl;						/**< ToDo:Describe short comment, about this member variable for Doxygen				*/
	CButton				m_wndPushBtn_add;					/**< ToDo:Describe short comment, about this member variable for Doxygen				*/
	CButton				m_wndPushBtn_edit;					/**< ToDo:Describe short comment, about this member variable for Doxygen				*/
	CButton				m_wndPushBtn_delete;				/**< ToDo:Describe short comment, about this member variable for Doxygen				*/
	CArray<BOOL>		bSelected;							/**< ToDo:Describe short comment, about this member variable for Doxygen				*/
	CButton				m_wndCheckBtn_footprint;			/**< ToDo:Describe short comment, about this member variable for Doxygen				*/
	CButton				m_wndCheckBtn_package;				/**< ToDo:Describe short comment, about this member variable for Doxygen				*/
	CButton				m_wndCheckBtn_value;				/**< ToDo:Describe short comment, about this member variable for Doxygen				*/
//--------------------------------------
// Generated message map function(s)
//--------------------------------------
protected:
	//{{AFX_MSG(CDlgPartlist)
	afx_msg void OnBnClickedButtonAdd();
	afx_msg void OnBnClickedButtonEdit();
	afx_msg void OnBnClickedButtonDelete();
	afx_msg void OnLvnColumnClickList1(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedValueVisible();
	afx_msg void OnBnClickedValueInvisible();
	afx_msg void OnNMClickList1(NMHDR *pNMHDR, LRESULT *pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
/*-----------------------------------------------------------------------------
							end of DlgPartlist.h
-----------------------------------------------------------------------------*/
