// DlgSetAreaHatch.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgSetAreaHatch.h"


// CDlgSetAreaHatch dialog

IMPLEMENT_DYNAMIC(CDlgSetAreaHatch, CDialog)

/*=============================================================================
						CDlgSetAreaHatch NX̍\z
=============================================================================*/

CDlgSetAreaHatch::CDlgSetAreaHatch(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgSetAreaHatch::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgSetAreaHatch)
	//}}AFX_DATA_INIT
}

/*=============================================================================
						CDlgSetAreaHatch NX̏
=============================================================================*/

CDlgSetAreaHatch::~CDlgSetAreaHatch()
{
}

/*=============================================================================
			CDlgSetAreaHatch _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgSetAreaHatch::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgSetAreaHatch)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_RADIO_HATCH_NONE, m_wndRadioBtn_none);
	DDX_Control(pDX, IDC_RADIO_HATCH_FULL, m_wndRadioBtn_full);
	DDX_Control(pDX, IDC_RADIO_HATCH_EDGE, m_wndRadioBtn_edge);
	if(pDX->m_bSaveAndValidate)				/* Rg[ϐ֒l擾	*/
	{
		if( m_wndRadioBtn_none.GetCheck() )
			m_hatch = CPolyLine::NO_HATCH;
		else if( m_wndRadioBtn_full.GetCheck() )
			m_hatch = CPolyLine::DIAGONAL_FULL;
		else if( m_wndRadioBtn_edge.GetCheck() )
			m_hatch = CPolyLine::DIAGONAL_EDGE;
	}
	else
	{
		if( m_hatch == CPolyLine::NO_HATCH )
			m_wndRadioBtn_none.SetCheck(1);
		else if( m_hatch == CPolyLine::DIAGONAL_FULL )
			m_wndRadioBtn_full.SetCheck(1);
		else if( m_hatch == CPolyLine::DIAGONAL_EDGE )
			m_wndRadioBtn_edge.SetCheck(1);
	}
}

/*=============================================================================
					CDlgSetAreaHatch NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgSetAreaHatch, CDialog)
	//{{AFX_MSG_MAP(CDlgSetAreaHatch)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CDlgSetAreaHatch message handlers

/*=============================================================================

=============================================================================*/

void CDlgSetAreaHatch::Init( int hatch )
{
	m_hatch = hatch;
}