#pragma once
#include "afxwin.h"


// CDlgSlot dialog

/*=============================================================================
						CDlgSlot _CAO NX̐錾
=============================================================================*/

class CDlgSlot : public CDialog
{
	DECLARE_DYNAMIC(CDlgSlot)
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
public:
	CDlgSlot(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDlgSlot();
	void Initialize( int units, int w, int travel, int dir, 
		int x, int y, BOOL bPlated=FALSE, BOOL bDrag=TRUE );
	void SetFields();
	void GetFields();
//--------------------------------------
// _CAO f[^(萔)
//--------------------------------------
protected:
	//{{AFX_DATA(CDlgSlot)
	enum { IDD = IDD_SLOT };
	//}}AFX_DATA
//--------------------------------------
// Override(s) - yz֐z
//--------------------------------------
	//{{AFX_VIRTUAL(CDlgSlot)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

public:
	BOOL		m_bDrag;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	BOOL		m_bPlated;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_units;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_x;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_y;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_w;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_travel;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_dir;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	// controls
private:
	CButton		m_wndRadioBtn_set;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_drag;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_plated;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndRadioBtn_unplated;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox	m_wndComboBox_units;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_x;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_y;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_w;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_travel;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox	m_wndComboBox_direction;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
//--------------------------------------
// Generated message map function(s)
//--------------------------------------
protected:
	//{{AFX_MSG(CDlgSlot)
	afx_msg void OnCbnSelChangeCombo1();
	afx_msg void OnBnClickedSet();
	afx_msg void OnBnClickedDrag();
	afx_msg void OnBnClickedPlated();
	afx_msg void OnBnClickedUnplated();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
/*-----------------------------------------------------------------------------
							end of DlgSlot.h
-----------------------------------------------------------------------------*/
