// DlgVia.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgVia.h"


// CDlgVia dialog

IMPLEMENT_DYNAMIC(CDlgVia, CDialog)

/*=============================================================================
						CDlgVia NX̍\z
=============================================================================*/

CDlgVia::CDlgVia(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgVia::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgVia)
	//}}AFX_DATA_INIT
}

/*=============================================================================
						CDlgVia NX̏
=============================================================================*/

CDlgVia::~CDlgVia()
{
}

/*=============================================================================
				CDlgVia _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgVia::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgVia)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_VIA_WIDTH, m_wndEditCtrl_via_w);
	DDX_Control(pDX, IDC_VIA_HOLE_WIDTH, m_wndEditCtrl_hole_w);
	if(!pDX->m_bSaveAndValidate)			/* ϐRg[	*/
	{
		// incoming
		CString str;
		str.Format(_T("%d"), m_via_w/NM_PER_MIL );
		m_wndEditCtrl_via_w.SetWindowText( str );
		str.Format(_T("%d"), m_via_hole_w/NM_PER_MIL );
		m_wndEditCtrl_hole_w.SetWindowText( str );
	}
	else
	{
		// outgoing
		CString str;
		m_wndEditCtrl_via_w.GetWindowText( str );
		m_via_w = GetDimensionFromString( str );
		if( m_via_w <= 0 )
		{
			AfxMessageBox(_T("Illegal via width"));
			pDX->Fail();
		}
		m_wndEditCtrl_hole_w.GetWindowText( str );
		m_via_hole_w = GetDimensionFromString( str );
		if( m_via_hole_w <= 0 )
		{
			AfxMessageBox(_T("Illegal via hole width"));
			pDX->Fail();
		}
	}
}

/*=============================================================================

=============================================================================*/

void	CDlgVia::Initialize(int via_w				/**< ToDo:Add Comment for Doxygen			*/
						   ,int via_hole_w			/**< ToDo:Add Comment for Doxygen			*/ )
{
	m_via_w = via_w;
	m_via_hole_w = via_hole_w;
}

/*=============================================================================
					CDlgVia NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgVia, CDialog)
	//{{AFX_MSG_MAP(CDlgVia)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CDlgVia message handlers
