// make Gerber file

enum
{
	 GERBER_BOARD_OUTLINE			= 0x1					/**< O`ǉ						*/
	,GERBER_AUTO_MOIRES				= 0x2					/**< tBʒu킹}[Nǉ			*/
	,GERBER_LAYER_TEXT				= 0x4					/**< o̓Cŵǉ			*/
	,GERBER_PILOT_HOLES				= 0x8					/**< pbhɃhp̃KChǉ		*/
	,GERBER_NO_PIN_THERMALS			= 0x10					/**< [hĩX[sT[}ɂȂ	*/
	,GERBER_NO_VIA_THERMALS			= 0x20					/**< rAT[}hɂȂ				*/
	,GERBER_MASK_VIAS				= 0x40					/**< \_WXgɃrÂ蔲쐬Ȃ	*/
	,GERBER_90_THERMALS				= 0x80					/**< ۃpbhp̃T[}90x]			*/
	,GERBER_RENDER_ALL				= 0x100					/**< K[oPNG`摜t@Cŏo͂		*/
	,GERBER_RENDER_TOP_BOTTOM		= 0x200					/**< K[ȍ㉺𔽓](T|[g???)		*/
	,GERBER_MIRROR_BOTTOM_PNG		= 0x400					/**< ʂ̃CPNGo͂ۂɔ]	*/
	,GERBER_NO_SMT_THERMALS			= 0x800					/**< \ʎ(SMT)pbhT[}ɂȂ		*/
	,GERBER_NO_CLEARANCE_SMCUTOUTS	= 0x1000				/**< \_}XN̔pbhƓlɈȂ	*/
	,GERBER_PLOT_INNER_NEGATIVE		= 0x2000				/**< wC(L1`L14)lKo͂			*/
};

class CAperture;

typedef CArray<CAperture,CAperture> aperture_array;

/*=============================================================================
					NX̐錾
=============================================================================*/

class CAperture
{
public:
	enum
	{
		 AP_NONE = 0					/**< ToDo:													*/
		,AP_CIRCLE						/**< ToDo:													*/
		,AP_SQUARE						/**< ToDo:													*/
		,AP_RECT						/**< ToDo:													*/
		,AP_RRECT						/**< ToDo:													*/
		,AP_MOIRE						/**< ToDo:													*/
		,AP_THERMAL						/**< ToDo:													*/
		,AP_RECT_THERMAL				/**< ToDo:													*/
		,AP_OCTAGON						/**< ToDo:													*/
		,AP_OVAL						/**< ToDo:													*/
	};
	int m_type;						// type of aperture, see enum above
	int m_size1, m_size2, m_size3;	// in NM
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
	CAperture();
	CAperture( int type, int size1, int size2, int size3=0 );
	~CAperture();
//--------------------------------------
// 
//--------------------------------------
	BOOL Equals( CAperture * ap ) const;
	int FindInArray( aperture_array * ap_array, BOOL ok_to_add=FALSE );
};

/*=============================================================================

=============================================================================*/
int		WriteGerberFile(CStdioFile * f					/**< ToDo:													*/
					   ,int flags						/**< ToDo:													*/
					   ,int layer						/**< ToDo:													*/
					   ,CDlgLog * log					/**< ToDo:													*/
					   ,int paste_mask_shrink			/**< ToDo:													*/
					   ,int fill_clearance				/**< ToDo:													*/
					   ,int mask_clearance				/**< ToDo:													*/
					   ,int pilot_diameter				/**< ToDo:													*/
					   ,int min_silkscreen_stroke_wid	/**< ToDo:													*/
					   ,int thermal_wid					/**< ToDo:													*/
					   ,int outline_width				/**< ToDo:													*/
					   ,int hole_clearance				/**< ToDo:													*/
					   ,int n_x							/**< ToDo:													*/
					   ,int n_y							/**< ToDo:													*/
					   ,int step_x						/**< ToDo:													*/
					   ,int step_y						/**< ToDo:													*/
					   ,const CArray<CPolyLine> * bd	/**< ToDo:													*/
					   ,const CArray<CPolyLine> * sm	/**< ToDo:													*/
					   ,CPartList * pl					/**< ToDo:													*/
					   ,CNetList * nl					/**< ToDo:													*/
					   ,CTextList * tl					/**< ToDo:													*/
					   ,CDisplayList * dl				/**< ToDo:													*/ );

int		WriteDrillFile(CStdioFile * file				/**< ToDo:													*/
					  ,const CPartList * pl				/**< ToDo:													*/
					  ,const CNetList * nl				/**< ToDo:													*/
					  ,const CArray<CPolyLine> * bd		/**< ToDo:													*/
					  ,int n_x=1						/**< ToDo:													*/
					  ,int n_y=1						/**< ToDo:													*/
					  ,int offset_x=0					/**< ToDo:													*/
					  ,int offset_y=0					/**< ToDo:													*/ );

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
/*-----------------------------------------------------------------------------
							end of Getber.h
-----------------------------------------------------------------------------*/
