#pragma once


// CMyFileDialog

class CMyFileDialog : public CFileDialog
{
	DECLARE_DYNAMIC(CMyFileDialog)

	enum { PARTS_ONLY, NETS_ONLY, PARTS_AND_NETS }; 
	enum { FREEPCB, PADSPCB }; 

//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
public:
	CMyFileDialog(BOOL bOpenFileDialog, // TRUE for FileOpen, FALSE for FileSaveAs
		LPCTSTR lpszDefExt = NULL,
		LPCTSTR lpszFileName = NULL,
		DWORD dwFlags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		LPCTSTR lpszFilter = NULL,
		CWnd* pParentWnd = NULL,
		DWORD dsize = sizeof(OPENFILENAME) );
	virtual ~CMyFileDialog();
	virtual BOOL OnFileNameOK();
	void Initialize( int flags );
	int m_flags;
	int m_format;

//--------------------------------------
// Override(s) - yz֐z
//--------------------------------------
	//{{AFX_VIRTUAL(CMyFileDialog)
protected:
	//}}AFX_VIRTUAL

protected:
	virtual BOOL OnInitDialog();
	virtual void DoDataExchange(CDataExchange* pDX);
	CButton m_wndRadioBtn_parts;
	CButton m_wndRadioBtn_nets;
	CButton m_wndRadioBtn_parts_and_nets;
	CButton m_wndRadioBtn_padspcb;
	CButton m_wndRadioBtn_freepcb;
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
/*-----------------------------------------------------------------------------
							end of MyFileDialog.h
-----------------------------------------------------------------------------*/
