// define standard drawing layers
//
#pragma once

/*=============================================================================

=============================================================================*/
enum
{
	// layout layers
	 LAY_SELECTION = 0						/**<  0: ToDo:Describe short comment, about this enum constant value for Doxygen				*/
	,LAY_BACKGND							/**<  1: ToDo:Describe short comment, about this enum constant value for Doxygen				*/
	,LAY_VISIBLE_GRID						/**<  2: ToDo:Describe short comment, about this enum constant value for Doxygen				*/
	,LAY_HILITE								/**<  3: ToDo:Describe short comment, about this enum constant value for Doxygen				*/
	,LAY_DRC_ERROR							/**<  4: ToDo:Describe short comment, about this enum constant value for Doxygen				*/
	,LAY_BOARD_OUTLINE						/**<  5: ToDo:Describe short comment, about this enum constant value for Doxygen				*/
	,LAY_RAT_LINE							/**<  6: ToDo:Describe short comment, about this enum constant value for Doxygen				*/
	,LAY_SILK_TOP							/**<  7: ToDo:Describe short comment, about this enum constant value for Doxygen				*/
	,LAY_SILK_BOTTOM						/**<  8: ToDo:Describe short comment, about this enum constant value for Doxygen				*/
	,LAY_SM_TOP								/**<  9: ToDo:Describe short comment, about this enum constant value for Doxygen				*/
	,LAY_SM_BOTTOM							/**< 10: ToDo:Describe short comment, about this enum constant value for Doxygen				*/
	,LAY_PAD_THRU							/**< 11: ToDo:Describe short comment, about this enum constant value for Doxygen				*/
	,LAY_TOP_COPPER							/**< 12: ToDo:Describe short comment, about this enum constant value for Doxygen				*/
	,LAY_BOTTOM_COPPER						/**< 13: ToDo:Describe short comment, about this enum constant value for Doxygen				*/
	//----------------------------------------
	// invisible layers
	//----------------------------------------
	,LAY_MASK_TOP = -100					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,LAY_MASK_BOTTOM = -101					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,LAY_PASTE_TOP = -102					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,LAY_PASTE_BOTTOM = -103				/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
};

/*=============================================================================
	// footprint layers
=============================================================================*/
enum
{
	 LAY_FP_SELECTION = 0					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,LAY_FP_BACKGND							/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,LAY_FP_VISIBLE_GRID					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,LAY_FP_HILITE							/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,LAY_FP_SILK_TOP						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,LAY_FP_CENTROID						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,LAY_FP_DOT								/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,LAY_FP_PAD_THRU						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,LAY_FP_TOP_MASK						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,LAY_FP_TOP_PASTE						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,LAY_FP_BOTTOM_MASK						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,LAY_FP_BOTTOM_PASTE					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,LAY_FP_TOP_COPPER						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,LAY_FP_INNER_COPPER					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,LAY_FP_BOTTOM_COPPER					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,NUM_FP_LAYERS							/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
};

/*=============================================================================

=============================================================================*/
static CONST TCHAR		layer_char[17]=_T("12345678QWERTYUI");

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
/*-----------------------------------------------------------------------------
							end of Layers.h
-----------------------------------------------------------------------------*/
